c*****7*****************************************************************
	subroutine chem
c-
c	This sublevel contains all routines to analyse a structure
c	line calculation of bondlength distributions, the average
c	structure and correlations.
c
c	Version  : 1.01
c	Date     : 23 May 1997
c	
c	Author   : Th. Proffen (proffen@rsc.anu.edu.au)
c+
	implicit	none
c
	include		'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'param.inc'
	include 	'prompt.inc'
	include 	'chem.inc'
c
	integer       	maxw
	parameter    	(maxw=MAXSCAT)
c
	character*5    	befehl
	character*11   	prom
	character*200  	line,zeile,cpara(maxw)
	real           	werte(maxw),wwerte(maxw),wwwerte(maxw),dir(3)
	integer        	lpara(maxw),lp,length
	integer        	indxg,ianz,lbef,i,ia,is,ic(3),iianz,jjanz
	logical        	lout
c
	logical         str_comp
c
	call no_error
c
10	continue
c
	prom=prompt//'/chem'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'syst',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                        str_comp(befehl,'?   ',2,lbef,4)) ) then
          call do_math(line,indxg,length)
c
c------ execute a macro file
c
        elseif(befehl(1:1).eq.'@') then
          call file_kdo(line(2:length),length-1)
c
c------ Calculate average structure and sigmas 'aver'
c
	elseif(str_comp(befehl,'aver',2,lbef,4)) then
	  call chem_aver (.true.)
c
c------ Calculate bond-length distribution 'blen'
c
	elseif(str_comp(befehl,'blen',2,lbef,4)) then
	  call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.ge.2) then
	      iianz=1
	      jjanz=1
	      call get_iscat (iianz,cpara(1),lpara(1),werte,
     &	                      maxw,.false.)
	      if (ier_num.eq.0) then
	        call get_iscat (jjanz,cpara(2),lpara(2),wwerte,
     &	                        maxw,.false.)  
	        if (ier_num.eq.0) then
	          call del_params (2,ianz,cpara,lpara,maxw)
	          call do_build_name (ianz,cpara,lpara,wwwerte,maxw,1)
	          chem_fname=cpara(1)
	          if (ier_num.eq.0) then
	            call chem_blen(iianz,jjanz,werte,wwerte,maxw)
	          endif
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------ Show chemical elements within the crystal 'chem'
c
	elseif(str_comp(befehl,'chem',3,lbef,4)) then
	  call show_chem
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',3,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
          write(*,'(1x,a)') zeile(1:79)
c
c------ Show relative amounts of elements 'elem'
c
	elseif(str_comp(befehl,'elem',2,lbef,4)) then
	  call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	  if (ianz.eq.1) then
	    call do_cap(cpara(1))
	    lout = (cpara(1)(1:2).eq.'ON')
	  else
	    lout = .true.
	  endif
	  call chem_elem (lout)
c
c------ Evaluate an expression 'eval'
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	exit 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------ calculate neighbour probabilities 'freq'
c
	elseif(str_comp(befehl,'freq',3,lbef,4)) then
	  call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.5) then
	      iianz=1
	      jjanz=1
	      call get_iscat(iianz,cpara(1),lpara(1), werte,maxw,.false.)
	      call get_iscat(jjanz,cpara(2),lpara(2),wwerte,maxw,.false.)
	      if (ier_num.eq.0) then
	        call del_params(2,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,wwwerte,maxw)
	        if (ier_num.eq.0) then
	          dir(1) = wwwerte(1)
	          dir(2) = wwwerte(2)
	          dir(3) = wwwerte(3)
	          call chem_freq (iianz,werte,jjanz,wwerte,maxw,dir)
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	help 'help','?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 12
	    call do_hel('discus chem '//zeile,lp)
	  endif
c
c------ set most parameters for 'chem' section: 'set'
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
	  call chem_set(zeile,lp)
c
c------ show parameters 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  call chem_show
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  if(zeile.ne. ' ') then
	    call do_operating(zeile(1:lp))
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ calc cell-atomindex and atomindex-cell
c
	elseif(str_comp(befehl,'trans',2,lbef,5)) then
	  call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.eq.0 .and. cr_natoms.ne.0) then
	    if (ianz.eq.1) then
	      ia=nint(werte(1))
	      if (ia.gt.0 .and. ia.le.cr_natoms) then
	        call indextocell (ia,ic,is)
	        write (*,3000) ia,ic,is
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    elseif (ianz.eq.4) then
	      is=nint(werte(4))
	      do i=1,3
	        ic(i)=nint(werte(i))
	      enddo
	      if (ic(1).gt.0 .and. ic(1).le.cr_icc(1) .and.
     &	          ic(2).gt.0 .and. ic(2).le.cr_icc(2) .and.
     &	          ic(3).gt.0 .and. ic(3).le.cr_icc(3) .and.
     &	          is   .gt.0 .and. is   .le.cr_ncatoms     ) then
	        call celltoindex (ic,is,ia)
	        write (*,3000) ia,ic,is
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif  
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif 
c
c------ Waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------ no command found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
c
c------ any errors ?
c
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
c
9999	continue
c
3000	format(' Atomindex ',I6,' : Unitcell ',3(I4,1X),
     &	       ' / site ',I2)
	end
c*****7*****************************************************************
	subroutine chem_show
c+
c	show current parameters
c-
	implicit	none
c
	include		'config.inc'
	include		'chem.inc'
	include		'errlist.inc'
c
	write (*,1000)
	if (chem_quick) then
	  write (*,1100) 'quick mode'
	else
	  write (*,1100) 'exact mode'
	endif
	write (*,1200) chem_blen_cut
	write (*,1300) chem_freq_sigma
	if (.not. chem_cang) then
	  write (*,1400)
	else
	  write (*,1450) chem_wink_sigma
	endif
	write (*,1500) chem_bin
	if (chem_io.eq.6) then
	  write (*,1600) ' Terminal '
	else
	  write (*,1600) ' File '//chem_outfile
	endif
c
1000	format (' Current settings in CHEM subsection :',/)
1100	format (' Calulation mode               : ',A11)
1200	format (' Allowed bond length range     : ',
     &	        F6.3,' A to ',F6.3,' A')
1300	format (' SIGMA for neighbour-distances : ',F6.3,' A')
1400	format (' SIGMA for neighbour-direction : NOT used')
1450	format (' SIGMA for neighbour-direction : ',F6.3,' degrees')
1500	format (' # points for histogramms      : ',I6)
1600	format (' Writing results to            : ',A)
	end
c*****7*****************************************************************
	subroutine chem_set (zeile,lp)
c+
c	sets most parameters for 'chem' section
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include 	'chem.inc'
c
	integer		maxw
	parameter	(maxw=MAXSCAT)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		ianz
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.eq.0) then
	  if (ianz.ge.2) then
	    call do_cap(cpara(1))
c
c------ --- 'set cryst': setting crystal dimensions
c
             if(cpara(1)(1:2).eq.'CR') then
               call del_params (1,ianz,cpara,lpara,maxw)
               if (ier_num.eq.0) then
                 if (ianz.eq.4) then
                   call ber_params(ianz,cpara,lpara,werte,4)
                   cr_icc(1)=nint(werte(1))
                   cr_icc(2)=nint(werte(2))
                   cr_icc(3)=nint(werte(3))
                   cr_ncatoms=nint(werte(4))
                 else
                   ier_num = -6
                   ier_typ = ER_COMM
                 endif
               endif
c
c------ --- set check: sets angle and symmetry check flag
c
	    elseif (cpara(1)(1:2).eq.'CH') then
	      if (ianz.eq.2 .or. ianz.eq.3) then
	        call do_cap(cpara(2))
	        chem_cang = (cpara(2)(1:2).eq.'ON')
	        if (ianz.eq.3) then
	          call do_cap(cpara(3))
	          chem_csym = (cpara(3)(1:2).eq.'ON')
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- set mode: set calculation mode to quick/exact
c
	    elseif (cpara(1)(1:2).eq.'MO') then
	      call do_cap(cpara(2))
	      chem_quick = (cpara(2)(1:3).eq.'QUI')
c
c------ --- set bin: set number of points for histogramm binning
c
	    elseif (cpara(1)(1:2).eq.'BI') then
	      if (ianz.eq.2) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if (nint(werte(1)).lt.chem_max_bin) then
	          chem_bin = nint(werte(1))
	        else
	          ier_num = -1
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- set blen: set allowed range for bond-length histogramm
c
	    elseif (cpara(1)(1:2).eq.'BL') then
	      if (ianz.eq.3) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if (ier_num.eq.0) then
	          if (werte(1).gt.0.01 .and. werte(2).gt.werte(1)) then
	            chem_blen_cut(1)=werte(1)
	            chem_blen_cut(2)=werte(2)
	          else
	            ier_num = -3
	            ier_typ = ER_CHEM
	          endif
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- set fsig: sets sigma for frequency calculation
c
	    elseif (cpara(1)(1:2).eq.'FS') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if (ier_num.eq.0) then
	        if (werte(1).gt.0.0) then
	          chem_freq_sigma=werte(1)
	        else
	          ier_num = -4
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- set output: controls file output of results
c
	    elseif (cpara(1)(1:3).eq.'OUT') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.eq.0) then
	        if (ianz.eq.1 .or. ianz.eq.2) then
	          if (chem_io.eq.66) close (66)
	          if (ianz.eq.2) chem_outfile=cpara(2)
	          call do_cap(cpara(1))
	          if (cpara(1)(1:2).eq.'ON') then
	            chem_io=66
	            open(chem_io,file=chem_outfile,status='unknown')
	          else
	            chem_io=6
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- set wsig: sets sigma for direction matching in freq
c
	    elseif (cpara(1)(1:2).eq.'WS') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if (ier_num.eq.0) then
	        if (werte(1).gt.0.0) then
	          chem_wink_sigma=werte(1)
	        else
	          ier_num = -4
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- unknown subcommand entered
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine chem_aver (lout)
c+
c	Calculate average structure and standard deviation
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'param.inc'
	include		'errlist.inc'
	include 	'chem.inc'
c
	real		p(3),ez(3)
	integer		i,j,k,ii,jj,kk,ia,is
	logical 	flag,lout
c
	character*9	at_name
c
c------ reset counters
c
	do i=1,cr_ncatoms
	  chem_ave_n(i)=0
	  do k=1,chem_max_ave
	    chem_ave_bese(i,k)=0.0
	  enddo
	  do j=1,3
	    chem_ave_pos(j,i)=0.0
	    chem_ave_sig(j,i)=0.0
	  enddo
	enddo
c
c------ loop over all unit cells ans atoms within unit cell
c
	do k=1,cr_icc(3)
	do j=1,cr_icc(2)
	do i=1,cr_icc(1)
	  ez(1)=cr_dim0(1,1)+float(i-1)
	  ez(2)=cr_dim0(2,1)+float(j-1)
	  ez(3)=cr_dim0(3,1)+float(k-1)
	  do ii=1,cr_ncatoms
	    ia=((k-1)*cr_icc(1)*cr_icc(2) +
     &	        (j-1)*cr_icc(1)           + (i-1))*cr_ncatoms+ii
	    do jj=1,3
	      p(jj)=cr_pos(jj,ia)-ez(jj)
	      chem_ave_pos(jj,ii)=chem_ave_pos(jj,ii)+p(jj)
	      chem_ave_sig(jj,ii)=chem_ave_sig(jj,ii)+p(jj)**2
	    enddo
c
c------ --- Calculate occupancies ..
c
	    if (chem_ave_n(ii).eq.0) then
	      chem_ave_n(ii)=1
	      chem_ave_iscat(ii,chem_ave_n(ii))=cr_iscat(ia)
	      is=1
	    else
	      flag=.true.
	      do kk=1,chem_ave_n(ii)
	        if (cr_iscat(ia).eq.chem_ave_iscat(ii,kk)) then
	          is=kk
	          flag=.false.
	        endif
	      enddo
	      if (flag) then
	        chem_ave_n(ii)=chem_ave_n(ii)+1
	        is=chem_ave_n(ii)
	        if (chem_ave_n(ii).gt.chem_max_ave) then
	          ier_typ = ER_CHEM
	          ier_num = -5
	          return
	        endif
	        chem_ave_iscat(ii,chem_ave_n(ii))=cr_iscat(ia)
	      endif
	    endif
	    chem_ave_bese(ii,is)=chem_ave_bese(ii,is)+1
	  enddo
	enddo
	enddo
	enddo
c
c------ output of average and sigma
c
	if (lout) write(chem_io,1000)
	ia=cr_icc(1)*cr_icc(2)*cr_icc(3)
	do i=1,cr_ncatoms
	  do j=1,3
	    chem_ave_pos(j,i)=chem_ave_pos(j,i)/float(ia)
            chem_ave_sig(j,i)=chem_ave_sig(j,i)/float(ia)-
     &                                          chem_ave_pos(j,i)**2
	    if (chem_ave_sig(j,i).gt.0.0) then
              chem_ave_sig(j,i)=sqrt(chem_ave_sig(j,i))
            else
              chem_ave_sig(j,i)=0.0
            endif
	  enddo
	  if (lout) then
	    write(chem_io,1100) i,(chem_ave_pos(ii,i),ii=1,3),
     &	                          (chem_ave_sig(ii,i),ii=1,3)
	    do k=1,chem_ave_n(i)
	      write(chem_io,1200) at_name(chem_ave_iscat(i,k)),
     &	                          chem_ave_bese(i,k)/ia
	    enddo
	  endif
	enddo
c
c------ store results in res_para
c
	if ((6*cr_ncatoms).gt.maxpar_res) then
	  ier_typ = ER_CHEM
	  ier_num = -2
	else
	  res_para(0)=6*cr_ncatoms
	  do i=1,cr_ncatoms
	    do j=1,3
	      res_para((i-1)*3+j  )=chem_ave_pos(j,i)
	    enddo 
	    do j=1,3
	      res_para((i-1)*3+j+3)=chem_ave_sig(j,i)
	    enddo 
	  enddo
	endif
c
1000	format (' Average structure : ',/)
1100	format (' Site ',I3,
     &	        ' : Position       : ',F7.4,',',F7.4,',',F7.4,/,
     &	        '            Sigma          : ',F7.4,',',F7.4,',',F7.4)
1200    format ('            Atom ',A9,' : ',F7.4)
	end
c*****7*****************************************************************
	subroutine chem_freq (iianz,werte,jjanz,wwerte,maxw,dir)
c+
c	Calculate neighbour-prob. within the crystal
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'atom_env.inc'
	include		'param.inc'
	include		'errlist.inc'
	include 	'chem.inc'
c
	integer		max_uvw
	parameter	(max_uvw=48)
c
	integer		maxw,iianz,jjanz
	real		werte(maxw),wwerte(maxw),dir(3)
c
	integer		i,j,k,ii,is,js
	integer		nneig
	real		pneig(2,2)
	real		u(3),v(3),w(3),uu(3)
	real		rmin,rmax,dummy
	real		pro00,pro01,pro11
	real		corr,thet
	logical		lfriedel_remove,lacentric
c
	integer		n_uvw
	real		uvw(4,max_uvw)
	real		uvw_mat(4,4,max_uvw)
c
	real		do_bang,do_blen
	logical		atom_allowed
c
c------ check input
c
	if (int(werte(1)).eq.-1 .or. int(wwerte(1)).eq.-1) then
	  ier_num = -6
	  ier_typ = ER_CHEM
	  return
	endif
c
	if (int(werte(1)).eq.int(wwerte(1))) then
	  ier_num = -7
	  ier_typ = ER_CHEM
	  return
	endif
c
c------ write output
c
	if (chem_quick) then
	  write (chem_io,400)
	else
	  write (chem_io,410)
	endif
c
c------ reset counters, vectors, ..
c
	do i=1,2
	  do j=1,2
	    pneig(i,j) = 0.0
	  enddo
	enddo
c
	do i=1,3
	  u(i) = 0.0
	  v(i) = 0.0
	  w(i) = 0.0
	enddo
c
c------ calculated neighbour distance
c
	rmax = do_blen(.true.,u,dir)
	rmin = rmax - chem_freq_sigma/2.0
	rmax = rmax + chem_freq_sigma/2.0
	write (chem_io,500) rmin,rmax,chem_wink_sigma,chem_cang,
     &	                    chem_csym,dir
c
c------ calculated sym. equivalent directions of [dir]
c
	do i=1,3
	  uvw(i,1)=dir(i)
	enddo
        uvw(4,1) = 0.0
        do i=1,4
          do j=1,4
            uvw_mat(i,j,1)=0.0
          enddo
          uvw_mat(i,i,1)=1.0
        enddo
c
        lfriedel_remove = .true.
        call rmc_symmetry (n_uvw,uvw,uvw_mat,max_uvw,
     &                     lfriedel_remove,lacentric)
	if (.not. chem_csym) n_uvw=1
c
c------ calculate frequencies
c
	dummy=-1
c
	do i=1,cr_natoms
	  is = -1
	  if (atom_allowed(i, werte,iianz,maxw)) is = 1
	  if (atom_allowed(i,wwerte,jjanz,maxw)) is = 2
	  if (is.gt.0) then
	    do j=1,3
	      u(j)=cr_pos(j,i)
	    enddo
	    call do_find_env(1,dummy,1,u,rmin,rmax,chem_quick)
	    if (atom_env(0).ne.0) then
	      do j=1,atom_env(0)
	        js = -1
	        if (atom_allowed(atom_env(j), werte,iianz,maxw)) js = 1
	        if (atom_allowed(atom_env(j),wwerte,jjanz,maxw)) js = 2
	        if (js.gt.0) then
c
c----- ---------- check neighbouring direction (chem_wink_sigma)
c
	          if (chem_cang) then
	            do k=1,n_uvw
	              do ii=1,3
	                v(ii) =cr_pos(ii,atom_env(j))-cr_pos(ii,i)
	                uu(ii)=uvw(ii,k)
	              enddo
	              if (abs(do_bang(.true.,v,w,uu)).lt.
     &	                                chem_wink_sigma) then
	                pneig(is,js)=pneig(is,js)+1.0
	              endif
	            enddo
c
c----- ------------ no check, just count neighbours in the correct
c----- ------------ distance
c
	          else
	            pneig(is,js)=pneig(is,js)+1.0
	          endif
	        endif
	      enddo
	    endif
	  endif
	enddo
c
c------ write results and save to res_para block
c
	nneig=nint(pneig(1,1)+pneig(2,2)+pneig(1,2)+pneig(2,1))
	if (nneig.ne.0) then
	  pro00=pneig(1,1)/float(nneig)
	  pro01=(pneig(1,2)+pneig(2,1))/float(nneig)
	  pro11=pneig(2,2)/float(nneig)
	  thet=0.5*(2.0*pneig(1,1)+pneig(1,2)+pneig(2,1))/float(nneig)
	  if (thet.ne.0 .and. thet.ne.1.0) then
	    corr=(pro00-thet**2)/(thet*(1-thet))
	  else
	    corr=0.0
	  endif
c
	  is=int( werte(1))
	  js=int(wwerte(1))
	  write(chem_io,1100) cr_at_lis(is),cr_at_lis(is),100.0*pro00
	  write(chem_io,1100) cr_at_lis(is),cr_at_lis(js),100.0*pro01
	  write(chem_io,1000) cr_at_lis(js),cr_at_lis(js),100.0*pro11,
     &	                      corr
	  write(chem_io,1200) nneig
c
	  res_para(0)=4
	  if (res_para(0).lt.maxpar_res) then
	    res_para(1)=pro00
	    res_para(2)=pro01
	    res_para(3)=pro11
	    res_para(4)=corr
	  else
	    ier_typ = ER_CHEM
	    ier_num = -2
	  endif
	else
	  ier_num = -8
	  ier_typ = ER_CHEM
	endif
c
 400	format (/,' Calculating frequencies (QUICK mode) ')
 410	format (/,' Calculating frequencies (EXACT mode) ')
 500	format (  '    Allowed neighbour-intervall    : ',
     &	               F6.3,' A to ',F6.3,' A ',/
     &	          '    Allowed angle difference       : ',
     &	               F6.3,' degrees (check = ',L1,', sym = ',L1,')',/
     &	          '    Neighbouring direction         : ',
     &	               3(F6.3,1X),/)
1000	format (  '    Pair probability   ',A4,' - ',A4,' : ',F6.2,' %',
     &	          '    (Correlation = ',F6.3,')')
1100	format (  '    Pair probability   ',A4,' - ',A4,' : ',F6.2,' %')
1200	format (/,'    Number of atom pairs included  : ',I8)
	end
c*****7*****************************************************************
	subroutine chem_blen(iianz,jjanz,werte,wwerte,maxw)
c+
c	Calculate bond length distribution within crystal
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'atom_env.inc'
	include		'param.inc'
	include		'errlist.inc'
	include 	'chem.inc'
c
	integer		maxw,iianz,jjanz
	real		werte(maxw),wwerte(maxw)
c
	integer		i,j,k,is,js,ibin
	integer		bl_anz(0:maxscat,0:maxscat)
	real		u(3)
	real		bl_min(0:maxscat,0:maxscat)
	real		bl_max(0:maxscat,0:maxscat)
	real		bl_sum(0:maxscat,0:maxscat)
	real		bl_s2 (0:maxscat,0:maxscat)
	real		bl_ave,bl_sig
c
	character*9	at_name
	logical		atom_allowed
c
c------ write output
c
	if (chem_quick) then
	  write (chem_io,400)
	else
	  write (chem_io,410)
	endif
	write (chem_io,500) chem_blen_cut,chem_fname,chem_bin
c
c------ Reset arrays
c
	do i=0,cr_nscat
	  do j=0,cr_nscat
	    bl_sum(i,j) =     0.0
	    bl_s2 (i,j) =     0.0
	    bl_anz(i,j) =     0
	    bl_min(i,j) =  1000.0
	    bl_max(i,j) = -1000.0
	  enddo
	enddo
	do i=1,chem_max_bin
	  chem_blen_hist(i)=0
	enddo
c
c------ Start the calculation
c
	do i=1,cr_natoms
	  if (atom_allowed(i,werte,iianz,maxw)) then
	    do j=1,3
	      u(j)=cr_pos(j,i)
	    enddo
	    call do_find_env (jjanz,wwerte,maxw,u,chem_blen_cut(1),
     &	                      chem_blen_cut(2),chem_quick)
	    if (ier_num.ne.0) return
	    do k=1,atom_env(0)
	      is = cr_iscat(i)
	      js = cr_iscat(atom_env(k))
	      bl_sum(is,js) = bl_sum(is,js) + res_para(k)
	      bl_s2 (is,js) = bl_s2 (is,js) + res_para(k)**2
	      bl_anz(is,js) = bl_anz(is,js) + 1
	      bl_min(is,js) = min (bl_min(is,js),res_para(k))
	      bl_max(is,js) = max (bl_max(is,js),res_para(k))

       	      ibin = int ((res_para(k)-chem_blen_cut(1))*chem_bin/ 
     &	                 (chem_blen_cut(2)-chem_blen_cut(1)))+1
	      chem_blen_hist(ibin)=chem_blen_hist(ibin)+1
	    enddo
	  endif
	enddo
c
c------ write output
c
	do i=0,cr_nscat
	  do j=i,cr_nscat
	    if (bl_anz(i,j).ne.0 .or. bl_anz(j,i).ne.0 ) then
	      bl_ave=(bl_sum(i,j)+bl_sum(j,i))/(bl_anz(i,j)+bl_anz(j,i))
	      bl_sig=(bl_s2 (i,j)+bl_s2 (j,i))/(bl_anz(i,j)+bl_anz(j,i))
	      bl_sig=sqrt(bl_sig-(bl_ave**2))
	      write(chem_io,1000) at_name(i),at_name(j),bl_ave,bl_sig,
     &	                          min(bl_min(i,j),bl_min(j,i)),
     &	                          max(bl_max(i,j),bl_max(j,i))
	    endif
	  enddo
	enddo
c
c------ write histogramm
c
	open (unit=43,file=chem_fname,status='unknown')
	do i=1,chem_bin
	  write (43,5000) chem_blen_cut(1) + 
     &	            (chem_blen_cut(2)-chem_blen_cut(1))*(i-1)/chem_bin,
     &	             chem_blen_hist(i)
	enddo
	close (43)
c
 400	format (/,' Calculating bond-length distibution (Mode: QUICK)')
 410	format (/,' Calculating bond-length distibution (Mode: EXACT)')
 500	format (' (Allowed range : ',F5.2,' A to ',F5.2,
     &	        '  A / File : ',A12,' (',I4,' pts))',/)
1000	format ('    ',A9,'- ',A9,': d = ',F6.3,' +- ',F6.3,' A ',
     &	        '(Min = ',F6.3,', Max = ',F6.3,')')
5000	format (F8.3,I12)
	end
c*****7*****************************************************************
	subroutine chem_elem (lout)
c+
c	Show information about elements/rel. amounts within crystal
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include		'param.inc'
	include 	'chem.inc'
c
	real		proz
	integer		natom(0:MAXSCAT)
	integer		i
	logical		lout
c
	character*9	at_name
c
c------ reset counters, ...
c
	do i=0,cr_nscat
	  natom(i)=0
	enddo
c
c------ get size of model crystal, rel. amount of elements
c
	do i=1,cr_natoms
	  natom(cr_iscat(i))=natom(cr_iscat(i))+1
	enddo
c
c------ write output
c
	if (lout) write (chem_io,1000) (cr_icc(i),i=1,3)
	if (lout) write (chem_io,1100) cr_natoms,cr_ncatoms,cr_nscat
	res_para(0)=float(cr_nscat)
	do i=0,cr_nscat
	  proz=float(natom(i))/cr_natoms
	  if (lout) write (chem_io,1200) at_name(i),proz,natom(i)
	  if (i.le.maxpar_res) then
	    res_para(i)=proz
	  else
	    ier_typ = ER_CHEM
	    ier_num = -2
	  endif
	enddo
c
1000	format (' Size of the crystal (unit cells) : ',2(I4,' x '),I4)
1100	format (' Total number of atoms            : ',I6,/
     &	        ' Number of atoms per unit cell    : ',I6,/
     &	        ' Number of different atoms        : ',I6,/)
1200	format ('    Element : ',A9,' rel. abundance : ',F5.3,
     &	        '  (',I6,' atoms)')
	end
c*****7***************************************************************
	character*9 function at_name(iscat)
c+
c	This function builds the atom name as XX(iscat) to be 
c	able to distinguish between different atom types with
c	the same name.
c-
	implicit      none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
c
	character*5	istr
	integer		iscat,il,is
c
	integer		len_str
c
	if (iscat.ge.100) then
	  write(istr,1000) iscat
	elseif (iscat.ge.10) then
	  write(istr,1100) iscat
	else 
	  write(istr,1200) iscat
	endif
c
	il=len_str(cr_at_lis(iscat))
	is=len_str(istr)
c
	at_name=cr_at_lis(iscat)(1:il)//istr(1:is)
c
1000	format ('(',I3,')')
1100	format ('(',I2,')')
1200	format ('(',I1,')')
	end
c*****7***************************************************************
	subroutine errlist_chem
c-
c	Displays error Messages for the error type RMC
c+
	implicit      none
c
	include      'errlist.inc'
c
	integer       iu,io
	parameter    (IU=-10,IO=0)
c
	character*41  ERROR(IU:IO)
c
	DATA ERROR/
     &  ' ',      !-10
     &  ' ',      ! -9
     &  'No neighbouring atoms found                ',      ! -8
     &  'Atoms need to be different                 ',      ! -7
     &  'Atom name ALL not allowed for this command ',      ! -6
     &  'Too many different atoms on ONE site       ',      ! -5
     &  'Invalid SIGMA entered                      ',      ! -4
     &  'Invalid range for bond-length histogramm   ',      ! -3
     &  'Not enough space for all results in res[]  ',      ! -2 
     &  'Too many points for histogramm             ',      ! -1 
     &  ' '       !  0
     &	/
c
	call disp_error ('CHEM',error,iu,io)
	end
C*****7****************************************************************
