c#########################################################################
c DISCUS Configuration file
c#########################################################################
c (1) Crystal dimensions
c
c	MAXSCAT : Maximum number of different atomtypes
c	NMAX    : Maximum number of atoms
c
	integer*4	MAXSCAT,NMAX
c
	parameter	(NMAX    = 100000)
	parameter	(MAXSCAT = 50)
c
c#########################################################################
c (2) Fourier transform
c
c	MAXQXY  : Maximum number of points in Q 
c	CFPKT   : Number of points in SIN(THETA/LAMBDA) lookup table
c	CFINC   : Increment for SIN(THETA/LAMBDA) table. The lookup
c	          table ranges from 0 to (CFPKT+1)*CFINC
c
	integer		MAXQXY,CFPKT
	real		CFINC
c
	parameter 	(MAXQXY = 301*301)
	parameter	(CFPKT  = 3999)
	parameter	(CFINC  = 0.001)
c
c#########################################################################
c (3) Reverse-Monte-Carlo
c
c	RMC_MAX_Q      : Maximum number of input data points (<= MAXQXY !)
c	RMC_MAX_PLANES : Maximum number of input data planes
c	RMC_MAX_SYM    : Maximum number of symmetrically equivalent planes
c	RMC_MAX_ATOM   : Maximum number of atoms moved in one RMC move
c
	integer		RMC_MAX_Q,RMC_MAX_PLANES,RMC_MAX_SYM
	integer		RMC_MAX_ATOM
c
	parameter	(RMC_MAX_Q      = MAXQXY)
	parameter	(RMC_MAX_PLANES = 5)
	parameter	(RMC_MAX_SYM    = 3)
	parameter	(RMC_MAX_ATOM   = 50)
c
c#########################################################################
c (4) Microdomains
c
c	MMAX         : Maximum number of atoms within a microdomain
c	MK_MAX_SCAT  : Maximum number of atom types within a microdomain
c	MC_MAX_MICRO : Maximum number of micro domains within the crystal
c
	integer		MMAX,MK_MAX_SCAT,MC_MAX_MICRO
c
	parameter	(MMAX         = 100)
	parameter	(MK_MAX_SCAT  = MAXSCAT)
	parameter	(MC_MAX_MICRO = 100)
c
c#########################################################################
c (5) Stacking faults
c
c	ST_MAXQXY    : Maximum number of points of Fourier (<= MAXQXY !)
c	ST_MAXLAYER  : Maximum number of layers
c	ST_MAXTYPE   : Maximum number of layer types
c
	integer		ST_MAXQXY,ST_MAXLAYER,ST_MAXTYPE
c
	parameter	(ST_MAXQXY   = MAXQXY)
	parameter	(ST_MAXLAYER = 1000)
	parameter	(ST_MAXTYPE  = 3)
c
