	program discus
c
	implicit 	none
	character*5	aktuell
	parameter	(aktuell='3.01 ')
c*****7*****************************************************************
c
c	Main program for DISCUS
c
c	This is the main program for DISCUS. It sets up most
c	variables and calls the loop interpreting the commands.
c
c	Authors : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c	          Th. Proffen (proffen@rsc.anu.edu.au)
c
c*****7*****************************************************************
	include 	'errlist.inc'
	include 	'doact.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'prompt.inc'
c
	character*200	line,zeile
	character*4	befehl
	logical       	lend
	integer       	laenge,lp,lbef
c                                         
	lend    = .false.
	blank   = ' '
	version = aktuell
	pname   = 'discus'
	pname_cap = 'DISCUS'
	prompt  = pname
	prompt_status=PROMPT_ON
c
c------ Setting up variables and print start screen
c
	call setup
	call no_error
c
c------ This is the main loop: reading commands ..
c
	do while(.not.lend)
	  call get_command (line,laenge,befehl,lbef,zeile,lp,prompt)
	  if(ier_num.eq.0 .and. laenge.gt.0) then
c
c------	- If not a comment continue
c
	    if(.not.(line(1:1).eq.'#' .or. line(1:1).eq.'!')) then
c
c------	- execute command
c
	      if(line(1:3).eq.'do ' .OR. line(1:2).eq.'if') then
	        call do_loop   (line,lend,laenge)
	      else
	        call mache_kdo (line,lend,laenge)
	      endif
	    endif
	  endif
c
c------	- Handle error message
c
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    lblock  = .false.
	    call no_error
	  endif
	enddo
c                             
9999	continue
	call do_exit
C
	end
c*****7*****************************************************************
	subroutine setup
c
c	This routine makes inital setup of DISCUS
c
	implicit      	none
c
	include 	'wink.inc'
	include 	'prompt.inc'
c
	zpi=8.00*atan(1.00)
	rad=zpi/360.00
	call ini_ran(0)
c
c------ Write starting screen
c
	write(*,1000) version
c
c------	Call initialization routine. Dummy except for f2c compiler
	call initarrays
c------	get envirmonment information
	call appl_env
c------	try to read default file
	call autodef
c
1000	format (/,10x,59('*'),/,10x,'*',15x,
     &	          'D I S C U S   Version ',
     &	          a5,15x,'*',/,10x,'*',57('-'),'*',/
     &            10x,'* (c) R.B. Neder  ',
     &	          '(neder@yoda.kri.physik.uni-muenchen.de) *',/,
     &	          10x,'*     Th. Proffen ',
     &            '(proffen@rsc.anu.edu.au)                *',/,
     &	          10x,59('*'),/)
	end
