C*****7*****************************************************************
	subroutine plot
c-
c	Write the structure properly formatted for structure display
c	programs and KUPLOT
c
c	Version  : 1.1
c	Date     : 06 Nov 96
c
c	Authors  : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c	           Th. Proffen (proffen@rsc.anu.edu.au)
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'plot.inc'
	include 	'prompt.inc'
c
	integer		maxw
	parameter	(maxw=MAXSCAT)
	logical		lold
	parameter	(lold=.false.)
c
	character*200	line,zeile,cpara(maxw)
	character*11	prom
	character*5	befehl
	character*1	cdum
	real		werte(maxw)
	integer		lpara(maxw),lp,length
	integer		ianz,i,j,is,it,ic,lbef
	logical		lend,l_select
c
	logical         str_comp
c
	include 	'microsta.inc'
c
	lend=.false.
c
	do while (.not. lend)
	  call no_error
	  prom=prompt//'/plot'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------ ----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',1,lbef,4)) then
              call show_asym
c
c------ ----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
              call show_chem
c
c------	----Set the sequence of columns 'colu'
c
	    elseif(str_comp(befehl,'colu',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(cpara(1).eq.'xyz' .or. cpara(1).eq.'yzx' .or.
     &	             cpara(1).eq.'zxy' .or. cpara(1).eq.'xzy' .or.
     &	             cpara(1).eq.'zyx' .or. cpara(1).eq.'yxz' ) then
	            pl_col = cpara(1)
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	--continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',3,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----Deselect which atoms are included in the plot 'dese'
c
	    elseif(str_comp(befehl,'dese',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(cpara(1)(1:3).eq.'mic') then
	          pl_md_s  = MD_S_EVE
	          pl_md_nr = 0
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                pl_latom(i) = .false.
	              enddo
	            else
	              do i=1,ianz
	                pl_latom(nint(werte(i))) = .false.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
              write(*,'(1x,a)') zeile(1:79)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',3,lbef,4)) then
	      lend=.true.
c
c------	----Select the extend of crystal space to be plotted 'exte'
c
	    elseif(str_comp(befehl,'exte',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1 .and. cpara(1)(1:3).eq.'all') then
	          do i=1,3
	            do j=1,2
	              pl_dim(i,j) = cr_dim(i,j)
	            enddo
	          enddo
	        elseif(ianz.eq.3) then
	          cdum = cpara(1)(1:1)
	          cpara(1) = '0.0'
	          lpara(1) = 3
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            if    (cdum.eq.'x') then
	              pl_dim(1,1) = werte(2)
	              pl_dim(1,2) = werte(3)
	            elseif(cdum.eq.'y') then
	              pl_dim(2,1) = werte(2)
	              pl_dim(2,2) = werte(3)
	            elseif(cdum.eq.'z') then
	              pl_dim(3,1) = werte(2)
	              pl_dim(3,2) = werte(3)
	            else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus plot '//zeile,lp)
	      endif
c
c------	----Select the reciprocal space direction normal to plot slice 'hkl'
c
	    elseif(str_comp(befehl,'hkl ',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_hkl(i) = werte(i)
	          enddo
	          call trans(pl_hkl,cr_rten,pl_uvw,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ define name of output file 'outf'
c
	    elseif(str_comp(befehl,'outf',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
                call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	        if(ier_num.eq.0) then
	          pl_out=cpara(1)
	        endif
	      endif
c
c------	----Select plotting program 'prog'
c
	    elseif(str_comp(befehl,'prog',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call do_cap(cpara(1))
	        if    (cpara(1)(1:1).eq.'K') then
	          pl_prog = 'kupl'
	        elseif(cpara(1)(1:1).eq.'G') then
	          pl_prog = 'gnuplot'
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----run plot 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      if(pl_out.ne.' ') then
	        if(.not. (pl_dim(1,1).eq.pl_dim(1,2) .and. 
     &	                  pl_dim(2,1).eq.pl_dim(2,2) .and. 
     &	                  pl_dim(3,1).eq.pl_dim(3,2) )) then
	          l_select = .false.
	          do i=0,cr_nscat
	            if(pl_latom(i)) then
	              l_select = .true.
	            endif
	          enddo
	          if(l_select) then
	            call do_plot
	          else
	            ier_num = -3
	            ier_typ = ER_APPL
	          endif
	        else
	          ier_num = -4
	          ier_typ = ER_APPL
	        endif
	      else
	        ier_num = -37
	        ier_typ = ER_APPL
	      endif
c
c------	----Select which atoms are included in the plot 'sele'
c
	    elseif(str_comp(befehl,'sele',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(cpara(1)(1:3).eq.'mic' .and. ianz.eq.2) then
	          if(cpara(2)(1:3).eq.'all') then
	            pl_md_s  = MD_S_ALL
	            pl_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'non') then
	            pl_md_s  = MD_S_NON
	            pl_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'eve') then
	            pl_md_s  = MD_S_EVE
	            pl_md_nr = 0
	          else
	            cpara(1) = '0.0'
	            lpara(1) = 3
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            pl_md_nr = nint(werte(2))
	            pl_md_s = MD_S_IND
	          endif
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                pl_latom(i) = .true.
	              enddo
	            else
	              do i=1,ianz
	                pl_latom(nint(werte(i))) = .true.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------	----set atom representation for KUPLOT
c
	    elseif(str_comp(befehl,'set',3,lbef,3)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if (ier_num.eq.0) then
	        if (ianz.eq.4) then
	          call get_iscat(1,cpara,lpara,werte,maxw,lold)
	          if (ier_num.eq.0) then
	            if (werte(1).ne.-1) then
	              is=nint(werte(1))
	              call del_params (1,ianz,cpara,lpara,maxw)
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              it=nint(werte(1))
	              ic=nint(werte(2))
	              if(ic.gt.0 .and. ic.le.6 .and. 
     &	                 it.gt.0 .and. it.le.10)     then
	                pl_typ(is)=it
	                pl_color(is)=ic
	                pl_siz(is)=werte(3)
	              else
	                ier_num = -59
	                ier_typ = ER_APPL
	              endif
	            else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      write(*,3000) pl_prog
	      write(*,3005) pl_out
	      if (pl_dens) then
	        write (*,3007) 'projection in single unit cell'
	      else
	        write (*,3007) 'crystal'
	      endif
	      write(*,3010) ((pl_dim(i,j),j=1,2),i=1,3)
	      write(*,3020) pl_col
	      write(*,3021) pl_hkl
	      write(*,3022) pl_uvw
	      write(*,3023) pl_vec
	      write(*,3024) pl_width
	      write(*,3030) cmic_s(pl_md_s)
	      if(pl_md_s.eq.MD_S_IND) then
	        write(*,3040) pl_md_nr
	      endif
	      write(*,3050)
	      do i=0,cr_nscat
	        if(pl_latom(i)) then
	          write(*,3060) i,cr_at_lis(i),pl_typ(i),pl_color(i),
     &	                        pl_siz(i)
	        endif
	      enddo
c
c------	----Set the half thickness of the plot slice in Angstroem 'thickness'
c
	    elseif(str_comp(befehl,'thic',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          pl_width  = werte(1)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select the direct space direction normal to plot slice 'uvw'
c
	    elseif(str_comp(befehl,'uvw ',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_uvw(i) = werte(i)
	          enddo
	          call trans(pl_uvw,cr_rten,pl_hkl,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select a point in direct space within the plot slice 'vec'
c
	    elseif(str_comp(befehl,'vec ',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_vec(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c-----  ------Operating System Kommandos 'syst'
c
	    elseif(str_comp(befehl,'syst',2,lbef,4)) then
	      if(zeile.ne. ' ') then
	        call do_operating(zeile)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----set typ of output
c
	    elseif(str_comp(befehl,'type',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if (ier_num.eq.0) then
	        if (ianz.eq.1) then
	          call do_cap(cpara(1))
	          pl_dens=(cpara(1)(1:1).eq.'P')
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
c
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	  endif
c
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
3000	format(' Plotting Program        : ',a)
3005	format(' Output file             : ',a)
3007	format(' Output type             : ',a)
3010	format(/' Extend of Crystal       : '/
     &	       ' Xmin, Xmax              : ',2(f8.3)/
     &	       ' Ymin, Ymax              : ',2(f8.3)/
     &	       ' Zmin, Zmax              : ',2(f8.3))
3020	format(' Sequence of coordinates : ',a)
3021	format(/' HKL of Normal           : ',3(f8.3))
3022	format(' UVW of Normal           : ',3(f8.3))
3023	format(' Point in plot slice     : ',3(f8.3))
3024	format(' Half thickness of slice : ',  f8.3 )
3030	format(/' select status           : ',a)
3040	format(26x,i4)
3050	format(' selected atoms          : ',
     &	       '  #  name  mtyp  color  size ')
3060	format(28x,i2,2x,a4,3x,i2,4x,i2,2x,f6.2)
	end
c*****7*****************************************************************
	subroutine do_plot
c
	implicit      	none
c
	integer       	iff
	parameter    	(iff=2)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'plot.inc'
c
	logical      	lread
c
	lread = .false.
	call oeffne(iff,pl_out,'unknown',lread)
	if(ier_num.eq.0) then
	  if(pl_prog.eq.'kupl' .or. pl_prog.eq.'gnuplot') then
	    call plot_kuplot(iff,(pl_prog.eq.'kupl'))
	  endif
	  close(iff)
	endif
c
	end
c*****7*****************************************************************
	subroutine plot_kuplot(iff,lkupl)
c-
c	Writes the selected atoms in a format suitable for plotting 
c	using GNUPLOT
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'plot.inc'
	include 	'microsta.inc'
	include 	'errlist.inc'
c
	real         	d,dist
	real         	v(3)
	integer      	i,j,iff
	logical      	lno_slice,latom,lkupl
c
	real         	skalpro
c
	latom = .false.
	if(pl_hkl(1).eq.0.and.pl_hkl(2).eq.0.and.pl_hkl(3).eq.0) then
	  lno_slice = .true.
	  d         = 1.0
	else
	  lno_slice = .false.
	  d         = sqrt(skalpro(pl_uvw,pl_uvw,cr_gten))
	endif
c
	do i=1,cr_natoms
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(pl_latom(cr_iscat(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    if(pl_dim(1,1) .le. cr_pos(1,i) .and.
     &	       cr_pos(1,i) .le. pl_dim(1,2) .and.
     &	       pl_dim(2,1) .le. cr_pos(2,i) .and.
     &	       cr_pos(2,i) .le. pl_dim(2,2) .and.
     &	       pl_dim(3,1) .le. cr_pos(3,i) .and.
     &	       cr_pos(3,i) .le. pl_dim(3,2)       ) then
c
c------	------Determine distance to point in plot slice
c
	      do j=1,3
	        v(j) = cr_pos(j,i) - pl_vec(j)
	      enddo
	      dist = abs(skalpro(pl_uvw,v,cr_gten))/d
c
c------	------Write atom if inside slice or if slice has been deselected
c
	      if(dist.le.pl_width .or. lno_slice) then
c
c------	------Write atom position in desired sequence of coordinates
c
	        latom = .true.
	        if    (pl_col.eq.'xyz') then
	          call write_atom(lkupl,iff,i,cr_pos(1,i),cr_pos(2,i),
     &	                          cr_pos(3,i))
	        elseif(pl_col.eq.'yzx') then
	          call write_atom(lkupl,iff,i,cr_pos(2,i),cr_pos(3,i),
     &	                          cr_pos(1,i))
	        elseif(pl_col.eq.'zxy') then
	          call write_atom(lkupl,iff,i,cr_pos(3,i),cr_pos(1,i),
     &	                          cr_pos(2,i))
	        elseif(pl_col.eq.'zyx') then
	          call write_atom(lkupl,iff,i,cr_pos(3,i),cr_pos(2,i),
     &	                          cr_pos(1,i))
	        elseif(pl_col.eq.'yxz') then
	          call write_atom(lkupl,iff,i,cr_pos(2,i),cr_pos(1,i),
     &	                          cr_pos(3,i))
	        elseif(pl_col.eq.'xzy') then
	          call write_atom(lkupl,iff,i,cr_pos(1,i),cr_pos(3,i),
     &	                          cr_pos(2,i))
	        endif
	      endif
	    endif
	  endif
	enddo
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
1000	format ('Structure : ',a)
	end
c*****7*****************************************************************
	subroutine write_atom(lkupl,iff,iatom,x,y,z)
c
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'plot.inc'
c
	real		x,y,z
	integer		iff,iatom,isite,icell(3)
	logical		lkupl
c
	if (pl_dens) then
	  call indextocell(iatom,icell,isite)
	  x=x-float(icell(1)-1)-cr_dim0(1,1)
	  y=y-float(icell(2)-1)-cr_dim0(2,1)
	  z=z-float(icell(3)-1)-cr_dim0(3,1)
	endif
c
	if (lkupl) then
	  write (iff,1000) x,y,z,pl_typ(cr_iscat(iatom)),
     &	                   pl_color(cr_iscat(iatom)),
     &	                   pl_siz(cr_iscat(iatom))
	else
	  write (iff,2000) x,y,z
	endif
c
1000    format(3(2x,f12.6),2(2x,i2),2x,f6.2)
2000    format(3(2x,f12.6))
	end
c*****7*****************************************************************
