c+
c	These routines create a new structure. The different options
c	are (or will be soon) :
c
c	  - comletely new structure
c	  - freestyle edited
c	  - generated from plane,space or non-crystallographic group
c	  - read-in structure
c	  - user written file
c	  - system catalog of standard structures
c
c	Version : 2.1
c	Date    : 13 May 96
c
c	Author  : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c
c*****7*****************************************************************
	subroutine read_struc
c-
c	Main menu for read command.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'prompt.inc'
c
	integer       	maxw
	parameter    	(maxw=11)
c
	character*200 	line,zeile,cpara(maxw)
	character*40  	strucfile
	character*11  	prom
	character*4	befehl
	integer       	lpara(maxw),lp,length
	integer       	ce_natoms,lstr,i,j,k,iatom
	integer       	ianz,l,n,lbef
	logical       	lout
	real          	hkl(3),u(3),xc(3),yc(3),zc(3),dist
	real          	werte(maxw)
c
	logical         str_comp
c
	call no_error
c
	blank = ' '
	lout  = .true.
c
	lstr      = 40
	cr_icc(1) =  1
	cr_icc(2) =  1
	cr_icc(3) =  1
c
	prom  = prompt//'/read'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#') goto 9999
c
c------ execute a macro file
c
        if(line(1:1).eq.'@') then
	  if(length.ge.2) then
	    call file_kdo(line(2:length),length-1)
	  else
	    ier_num = -13
	    ier_typ = ER_MAC
	  endif
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
          write(*,'(1x,a)') zeile(1:79)
c
c------	execute command
c------	help
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(zeile.eq.' ') then
	    zeile='commands'
	    lp   = lp + 8
	  endif
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 12
	    call do_hel('discus read '//zeile,lp)
	  endif
c
c------  -----waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
	else
c
c------	--all other commands
c
c------	--get command parameters
c
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
c
c------	--Build file name
c
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if(ier_num.ne.0) then
	    return
	  endif
c
c------	--reset epsilon tensors
c
      	  do i=1,3
      	    do j=1,3
      	      do k=1,3
      	        cr_eps(i,j,k) =0.0
     	        cr_reps(i,j,k)=0.0
	      enddo
	    enddo
	  enddo
c
c------	read in old cell, use space group symbol to generate cell
c------	content 'cell'
c 
	  if    (str_comp(befehl,'cell',1,lbef,4)) then
	    if(ianz.ge.1) then
	      call rese_cr
	      strucfile=cpara(1)
	      if(ier_num.eq.0) then
c
c------	--------if necessary get crystal size
c
	        if(ianz.gt.1) then
	          cpara(1)='0.0'
	          lpara(1)=3
                  call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do i=1,ianz-1
	              cr_icc(i) = nint(werte(i+1))
	            enddo
	          endif
	        endif
	        if(ier_num.eq.0) then
	          call readcell(strucfile)
	          if(ier_num.eq.0) then
c
c------	----------check whether total number of atoms fits into available
c------	----------space
c
	          iatom = cr_icc(1)*cr_icc(2)*cr_icc(3)*cr_natoms
	          if(iatom.gt.nmax) then
	            ier_num = -10
	            ier_typ = ER_APPL
	            write(ier_msg(1),3000) cr_icc(1),cr_icc(2),cr_icc(3)
	            write(ier_msg(2),3100) cr_natoms
	            write(ier_msg(3),3200) iatom,nmax
3000	            format('Unit cells   : ',3(i4,2x))
3100	            format('Atoms / cell : ',i10)
3200	            format('Total / max  : ',i10,'/',i10)
	            return
	          endif
	          do l=1,3
	            do j=1,2
                      cr_dim(l,j)=cr_pos(l,j)
	            enddo
	          enddo
	          ce_natoms =cr_natoms
	          cr_ncatoms=cr_natoms
	          cr_natoms =0
	          do k=1,cr_icc(3)
	            do j=1,cr_icc(2)
	              do i=1,cr_icc(1)
	                do n=1,ce_natoms
	                  cr_natoms=cr_natoms+1
                          cr_iscat(cr_natoms)=cr_iscat(n)
	                  cr_pos(1,cr_natoms)=cr_pos(1,n)+float(i-1)
	                  cr_pos(2,cr_natoms)=cr_pos(2,n)+float(j-1)
	                  cr_pos(3,cr_natoms)=cr_pos(3,n)+float(k-1)
	                  do l=1,3
                            cr_dim(l,1)=amin1(cr_dim(l,1),
     &	                                      cr_pos(l,cr_natoms))
                            cr_dim(l,2)=amax1(cr_dim(l,2),
     &	                                      cr_pos(l,cr_natoms))
	                  enddo
	                enddo
	              enddo
	            enddo
	          enddo
c
c------	----------Define initial crystal size in fractional coordinates
c
	          do l=1,3
	            cr_dim0(l,1) = float(nint(cr_dim(l,1)))
	            cr_dim0(l,2) = float(nint(cr_dim(l,2)))
	          enddo
	          endif
	        endif
	      endif
	    endif
	    if(ier_num.eq.0) then
c
c------	------reset microdomain status
c
	      call micro_reset
	      call do_stack_rese
	    endif
c
c------	Free style editing of a structure 'free'
c
	  elseif(str_comp(befehl,'free',1,lbef,4)) then
	    cr_name='      '
	    cr_spcgr(1:1)='P'
	    cr_spcgr(2:2)='1'
	    cr_spcgr(3:16)='              '
	    cr_spcgrno    = 1
	    if(ianz.eq.0) then
	      do i=1,3
	        cr_a0(i)=1.0
	        cr_win(i)=90.0
	      enddo
	    elseif(ianz.eq.6) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
	      do i=1,3
	        cr_a0(i)  = werte(i  )
	        cr_win(i) = werte(i+3)
	      enddo
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	      return
	    endif
	    cr_icc(1) = 1
	    cr_icc(2) = 1
	    cr_icc(3) = 1
	    cr_natoms = 0
	    cr_nscat  = 0
	    as_natoms = 0
c
c------	----reset microdomain status
c
	    call micro_reset
	    call do_stack_rese
c
c------	read an old structure 'stru'
c
	  elseif(str_comp(befehl,'stru',1,lbef,4)) then
	    if(ianz.eq.1) then
	      call rese_cr
	      strucfile=cpara(1)
	      call readstru(strucfile,cr_name,cr_spcgr,
     &	                    cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                    cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                    cr_dim,
     &	                    as_natoms,as_at_lis,as_dw,as_pos,as_iscat)
c
c------	------Define initial crystal size in fractional coordinates
c
	      do l=1,3
	        cr_dim0(l,1) = float(nint(cr_dim(l,1)))
	        cr_dim0(l,2) = float(nint(cr_dim(l,2)))
	      enddo
c
c------	------Define initial crystal size in number of unit cells
c
	      do i=1,3
                cr_icc(i) = max(1,int(cr_dim0(i,2)-cr_dim0(i,1)))
	      enddo
c
c------	------Define (average) number of atoms per unit cell
c
	      cr_ncatoms = cr_natoms / (cr_icc(1)*cr_icc(2)*cr_icc(3))
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	    if(ier_num.eq.0) then
c
c------	------reset microdomain status
c
	      call micro_reset
	      call do_stack_rese
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    goto 9999
	  endif  
	  if(ier_num.eq.0) then
	    write(*,1000) cr_spcgr,cr_spcgrno
c.......calculate metric and reciprocal metric tensor,reciprocal lattice
c       constants and permutation tensors
            call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	    cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	    cr_vr,lout)
C
	    do i=1,3
	      hkl(i)=0.0
	      u  (i)=0.0
	    enddo
	    hkl(3)=1.0
	    call trafo(hkl,u,xc,yc,zc,cr_gmat,cr_fmat,dist,cr_eps,
     &	               cr_gten,cr_reps,cr_rten)
	      call recip_symm
	  else
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	endif
c
9999	continue
c
1000	format(1x,a16,i5)
	end
c**********************************************************************
      	subroutine readcell(strucfile)
c-
c     	This subroutine reads a unit cell.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       	ist,maxw
	parameter	(ist=7,maxw=4)
c
	character*40  	strucfile
	character*200 	line
	integer       	i,j,ibl
	logical       	lread
	real          	werte(maxw),dw1
c
	cr_natoms = 0
	lread     = .true.
	call oeffne(ist,strucfile,'old',lread)
	if(ier_num.eq.0) then
	  do i=1,3
	    cr_dim(i,1) =  1.e10
	    cr_dim(i,2) = -1.e10
	  enddo
c
c------	--Read header of structure file
c
	  call stru_readheader(ist)
c
	  if(ier_num.eq.0) then
	    do while(cr_natoms .lt. nmax)
	      ier_num = -49
	      ier_typ = ER_APPL
	      line=' '
	      read(ist,2000,end=2,err=999) line
	      if(line .ne. ' ') then
	        ibl= index(line,' ' )+1
	        read(line(ibl:80),*,end=999,err=999) (werte(j),j=1,4)
	        cr_natoms = cr_natoms + 1
	        i         = cr_natoms
c
c------	----------Transform atom into first unit cell
c
	        call firstcell(werte,maxw)
c
	        do j=1,3
	          cr_pos(j,i)=werte(j)
	        enddo
	        dw1=werte(4)
	        if(line(1:4).ne.'    ') then
	          ibl = ibl - 1
	          call do_cap(line(1:ibl))
	          if(cr_nscat.lt.maxscat) then
	            cr_nscat            = cr_nscat+1
	            cr_iscat(i)         = cr_nscat
	            cr_at_lis(cr_nscat) = line(1:ibl)
	            cr_dw(cr_nscat)     = dw1
c
	            as_natoms             = as_natoms + 1
                    as_at_lis(cr_nscat)   = cr_at_lis(cr_nscat)
                    as_iscat(as_natoms)   = cr_iscat(i)
	            as_dw(as_natoms)      = cr_dw(cr_nscat)
	            do j=1,3
	              as_pos(j,as_natoms) = cr_pos(j,i)
	            enddo
	            call symmetry
	          else
	            ier_num = -26
	            ier_typ = ER_APPL
	            goto 2
	          endif
	        endif
	      endif
	    enddo
	  endif
c
2	  continue
	  if(ier_num.eq.-49) then
	    ier_num = 0
	    ier_typ = ER_NONE
c
c------	  move first unit cell into lower left corner of crystal
c
	    do i=1,cr_natoms
	      do j=1,3
	        cr_pos(j,i)=cr_pos(j,i) - int((cr_icc(j)    )/2)
c	        cr_pos(j,i)=cr_pos(j,i) - int((cr_icc(j)-0.1)/2)
                cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
                cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	      enddo
	    enddo
	  endif
c
	endif
c
999	continue
	close(ist)
	if(ier_num.eq.-49 ) then
	  write(ier_msg(1),3000) as_natoms+1
3000	  format('At atom number = ',i8)
	endif
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
      	subroutine readstru(strucfile,cr_name,cr_spcgr,cr_a0,
     &	                    cr_win,cr_natoms,cr_nscat,cr_dw,
     &	                    cr_at_lis,cr_pos,cr_iscat,cr_dim,
     &	                    as_natoms,as_at_lis,as_dw,as_pos,
     &	                    as_iscat)
c-
c     	this subroutine reads an old structur.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'errlist.inc'
c
	integer       	ist,maxw
	parameter	(ist=7,maxw=4)
c
	character*40  	strucfile
	character*200 	line,cpara(maxw)
	integer       	i,ianz
	integer       	lpara(maxw),lp
	logical       	lread
	real          	werte(maxw)
c
	integer       	len_str
c
	cr_natoms = 0
	lread     = .true.
	call oeffne(ist,strucfile,'old',lread)
	if(ier_num.eq.0) then
	  do i=1,3
	    cr_dim(i,1) =  1.e10
	    cr_dim(i,2) = -1.e10
	  enddo
c
c------	--Read header of structure file
c
	  call stru_readheader(ist)
c
	  if(ier_num.eq.0) then
	    call struc_read_atoms(
     &	      cr_natoms,cr_nscat,
     &	      cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	      cr_dim,as_natoms,as_at_lis,as_dw,
     &	      as_pos,as_iscat)
	  endif
	endif
c
999	continue
	close(ist)
	if(ier_num.eq.-49 ) then
	  write(ier_msg(1),3000) cr_natoms+1
3000	  format('At atom number = ',i8)
	endif
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
	subroutine stru_readheader(ist)
c-
c	This subroutine reads the header of a structure file
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       	maxw
	parameter	(maxw=4)
c
	character*200 	line,cpara(maxw)
	character*200   zeile
	character*6     befehl
	integer         ist,i,ll
	integer       	ianz
	integer       	spcgr_ianz
	integer       	lpara(maxw),lp
	integer         lbef,indxb
	real            spcgr_para
	real          	werte(maxw)
c
	integer       	len_str
	logical         str_comp
c
	ier_num = -46
	ier_typ = ER_APPL
	read(ist,2000,end=999,err=999)  cr_name
c
c------	This construction is needed as long a the old cell file format
c	must be supported.
c
c
c------	The maximum number of significant characters depends on the length of
c------	the character constant befehl.
c
	lbef   = len(befehl)
	befehl = '    '
	indxb  = index(cr_name,' ')
	lbef   = min(indxb-1,lbef)
	befehl = cr_name(1:lbef)
	if    (str_comp(befehl,'title',1,lbef,5)) then
c
c------	Read new header
c
	  ier_num = 0
	  ier_typ = ER_NONE
	  do while( .not. str_comp(befehl,'atoms',1,lbef,5) )
	    read(ist,2000,end=999,err=999)  line
	    ll     = 200
	    ll     = len_str(line)
c
c------	----The maximum number of significant characters depends on the 
c------	----length of the character constant befehl.
c
	    lbef   = len(befehl)
	    befehl = '    '
	    indxb  = index(line,' ')
	    lbef   = min(indxb-1,lbef)
	    befehl = line(1:lbef)
c
c------	----command parameters start at the first character following 
c------ ----the blank
c
	    zeile = ' '
	    lp    = 0
	    if(indxb+1 .le. ll) then
	      zeile = line(indxb+1:ll)
	      lp    = ll - indxb
	    endif
c
c------	----Space group symbol
c
	    if(str_comp(befehl,'spcgr',1,lbef,5) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      cr_spcgr   = cpara(1)
	      spcgr_ianz = ianz -1
	      ianz       = ianz -1
	      if(ianz.eq.1) then
	        cpara(1) = cpara(2)
	        lpara(1) = lpara(2)
                call ber_params(ianz,cpara,lpara,werte,maxw)
		spcgr_para = werte(1)
	      endif
	      if(ier_num.ne.0) then
	        ier_num = -47
	        ier_typ = ER_APPL
		return
	      endif
c
c------	----Cell constants
c
	    elseif(str_comp(befehl,'cell',1,lbef,4) ) then
	      ier_num = -48
	      ier_typ = ER_APPL
	      read(zeile,*,end=999,err=999) 
     &	          (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	      ier_num = 0
	      ier_typ = ER_NONE
c
	    elseif(str_comp(befehl,'atoms',1,lbef,5) ) then
	      continue
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  enddo
c
	  ier_num = 0
	  ier_typ = ER_NONE
c
c------	--Determine space group number
c
	  werte(1) = spcgr_para
	  call spcgr_no(spcgr_ianz,maxw,werte)
	else
c
c------	Read old header
c
	  ier_num = -47
	  ier_typ = ER_APPL
	  read(ist,2010,end=999,err=999)  line
	  lp = len_str(line)
          call get_params(line,ianz,cpara,lpara,maxw,lp)
	  cr_spcgr = cpara(1)
	  ianz = ianz -1
	  if(ianz.eq.1) then
	    cpara(1) = cpara(2)
	    lpara(1) = lpara(2)
            call ber_params(ianz,cpara,lpara,werte,maxw)
	  endif
	  if(ier_num.eq.0) then
	    ier_num = -48
	    ier_typ = ER_APPL
	    read(ist,*,end=999,err=999) 
     &	        (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	    ier_num = 0
	    ier_typ = ER_NONE
	    call spcgr_no(ianz,maxw,werte)
	  endif
	endif
c
999	continue
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
	subroutine struc_read_atoms(cr_natoms,cr_nscat,cr_dw,
     &	                            cr_at_lis,cr_pos,cr_iscat,
     &	                            cr_dim,as_natoms,as_at_lis,
     &	                            as_dw,as_pos,as_iscat)
c-
c     	This subroutine reads the list of atoms into the crystal array
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'errlist.inc'
c
	integer       	ist,maxw
	parameter    	(ist=7,maxw=4)
c
	character*200 	line
	integer       	i,j,ibl
	real          	werte(maxw),dw1
c
	do while(cr_natoms .lt. nmax)
	  ier_num = -49
	  ier_typ = ER_APPL
	  line=' '
	  read(ist,2000,end=2,err=999) line
	  if(line .ne. ' ') then
	    ibl= index(line,' ' )+1
	    read(line(ibl:80),*,end=999,err=999) (werte(j),j=1,4)
	    cr_natoms = cr_natoms + 1
	    i         = cr_natoms
	    do j=1,3
	      cr_pos(j,i)=werte(j)
              cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
              cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	    enddo
	    dw1=werte(4)
	    if(line(1:4).ne.'    ') then
	      ibl = ibl - 1
	      call do_cap(line(1:ibl))
	      do j=0,cr_nscat
                if(line(1:ibl).eq.cr_at_lis(j) .and.
     &	           dw1        .eq.cr_dw(j)          ) then
                cr_iscat(i)=j
                  goto 11
                endif
	      enddo
              cr_nscat            = cr_nscat+1
              cr_iscat(i)         = cr_nscat
              cr_at_lis(cr_nscat) = line(1:ibl)
              cr_dw(cr_nscat)=dw1
c
	      if(0.0 .le. cr_pos(1,i) .and. cr_pos(1,i).lt.1 .and.
     &	         0.0 .le. cr_pos(2,i) .and. cr_pos(2,i).lt.1 .and.
     &	         0.0 .le. cr_pos(3,i) .and. cr_pos(3,i).lt.1) then
	        as_natoms             = as_natoms + 1
                as_at_lis(cr_nscat)   = cr_at_lis(cr_nscat)
                as_iscat(as_natoms)   = cr_iscat(i)
	        as_dw(as_natoms)      = cr_dw(cr_nscat)
	        do j=1,3
	          as_pos(j,as_natoms) = cr_pos(j,i)
	        enddo
	      endif
11            continue
	    endif
	  endif
	enddo
c
2	continue
	if(ier_num.eq.-49) then
	  ier_num = 0
	  ier_typ = ER_NONE
	endif
c
999	continue
	close(ist)
c
2000	format(a)
	end
c**********************************************************************
	subroutine spcgr_no(ianz,maxw,werte)
c-
c	Interprets the space group symbol. Returns the space group no.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       	ianz,maxw,ii
	real          	werte(maxw)
c
	ier_num = 0
	ier_typ = ER_NONE
	if(ianz.eq.1) then
	  ii = nint(werte(1))
	endif
	ianz =ianz+1
c
	if    (cr_spcgr.eq.'P1              ') then
	  cr_spcgrno =   1
	  cr_syst    =   1
	elseif(cr_spcgr.eq.'P-1             ') then
	  cr_spcgrno =   2
	  cr_syst    =   1
	elseif(cr_spcgr.eq.'P2              ') then
	  cr_spcgrno =   3
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P21             ') then
	  cr_spcgrno =   4
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'C2              ') then
	  cr_spcgrno =   5
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'Pm              ') then
	  cr_spcgrno =   6
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'Pc              ') then
	  cr_spcgrno =   7
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'Cm              ') then
	  cr_spcgrno =   8
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'Cc              ') then
	  cr_spcgrno =   9
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P2/m            ') then
	  cr_spcgrno =  10
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P21/m           ') then
	  cr_spcgrno =  11
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'C2/m            ') then
	  cr_spcgrno =  12
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P2/c            ') then
	  cr_spcgrno =  13
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P21/c           ') then
	  cr_spcgrno =  14
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'C2/c            ') then
	  cr_spcgrno =  15
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P222            ') then
	  cr_spcgrno =  16
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'P2221           ') then
	  cr_spcgrno =  17
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'P21212          ') then
	  cr_spcgrno =  18
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'P212121         ') then
	  cr_spcgrno =  19
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'C2221           ') then
	  cr_spcgrno =  20
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'C222            ') then
	  cr_spcgrno =  21
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'F222            ') then
	  cr_spcgrno =  22
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'I222            ') then
	  cr_spcgrno =  23
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'I212121         ') then
	  cr_spcgrno =  24
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmm2            ') then
	  cr_spcgrno =  25
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmc21           ') then
	  cr_spcgrno =  26
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pcc2            ') then
	  cr_spcgrno =  27
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pma2            ') then
	  cr_spcgrno =  28
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pca21           ') then
	  cr_spcgrno =  29
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnc2            ') then
	  cr_spcgrno =  30
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmn21           ') then
	  cr_spcgrno =  31
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pba2            ') then
	  cr_spcgrno =  32
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pna21           ') then
	  cr_spcgrno =  33
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnn2            ') then
	  cr_spcgrno =  34
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmm2            ') then
	  cr_spcgrno =  35
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmc21           ') then
	  cr_spcgrno =  36
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ccc2            ') then
	  cr_spcgrno =  37
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Amm2            ') then
	  cr_spcgrno =  38
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Abm2            ') then
	  cr_spcgrno =  39
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ama2            ') then
	  cr_spcgrno =  40
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Aba2            ') then
	  cr_spcgrno =  41
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Fmm2            ') then
	  cr_spcgrno =  42
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Fdd2            ') then
	  cr_spcgrno =  43
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Imm2            ') then
	  cr_spcgrno =  44
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Iba2            ') then
	  cr_spcgrno =  45
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ima2            ') then
	  cr_spcgrno =  46
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmmm            ') then
	  cr_spcgrno =  47
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnnn            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  48
	    cr_syst    =   4
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  48
	      cr_syst    =   4
	    elseif(ii.eq.2) then
	      cr_spcgrno = 276
	      cr_syst    =   4
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Pccm            ') then
	  cr_spcgrno =  49
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pban            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  50
	    cr_syst    =   4
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  50
	      cr_syst    =   4
	    elseif(ii.eq.2) then
	      cr_spcgrno = 277
	      cr_syst    =   4
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Pmma            ') then
	  cr_spcgrno =  51
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnna            ') then
	  cr_spcgrno =  52
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmna            ') then
	  cr_spcgrno =  53
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pcca            ') then
	  cr_spcgrno =  54
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pbam            ') then
	  cr_spcgrno =  55
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pccn            ') then
	  cr_spcgrno =  56
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pbcm            ') then
	  cr_spcgrno =  57
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnnm            ') then
	  cr_spcgrno =  58
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pmmn            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  59
	    cr_syst    =   4
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  59
	      cr_syst    =   4
	    elseif(ii.eq.2) then
	      cr_spcgrno = 278
	      cr_syst    =   4
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Pbcn            ') then
	  cr_spcgrno =  60
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pbca            ') then
	  cr_spcgrno =  61
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Pnma            ') then
	  cr_spcgrno =  62
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmcm            ') then
	  cr_spcgrno =  63
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmca            ') then
	  cr_spcgrno =  64
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmmm            ') then
	  cr_spcgrno =  65
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cccm            ') then
	  cr_spcgrno =  66
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Cmma            ') then
	  cr_spcgrno =  67
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ccca            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  68
	    cr_syst    =   4
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  68
	      cr_syst    =   4
	    elseif(ii.eq.2) then
	      cr_spcgrno = 279
	      cr_syst    =   4
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Fmmm            ') then
	  cr_spcgrno =  69
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Fddd            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  70
	    cr_syst    =   4
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  70
	      cr_syst    =   4
	    elseif(ii.eq.2) then
	      cr_spcgrno = 280
	      cr_syst    =   4
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Immm            ') then
	  cr_spcgrno =  71
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ibam            ') then
	  cr_spcgrno =  72
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Ibca            ') then
	  cr_spcgrno =  73
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'Imma            ') then
	  cr_spcgrno =  74
	  cr_syst    =   4
	elseif(cr_spcgr.eq.'P4              ') then
	  cr_spcgrno =  75
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P41             ') then
	  cr_spcgrno =  76
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42             ') then
	  cr_spcgrno =  77
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P43             ') then
	  cr_spcgrno =  78
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I4              ') then
	  cr_spcgrno =  79
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I41             ') then
	  cr_spcgrno =  80
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-4             ') then
	  cr_spcgrno =  81
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I-4             ') then
	  cr_spcgrno =  82
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/m            ') then
	  cr_spcgrno =  83
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42/m           ') then
	  cr_spcgrno =  84
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/n            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  85
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  85
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 281
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P42/n           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  86
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  86
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 282
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'I4/m            ') then
	  cr_spcgrno =  87
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I41/a           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno =  88
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno =  88
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 283
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P422            ') then
	  cr_spcgrno =  89
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4212           ') then
	  cr_spcgrno =  90
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4122           ') then
	  cr_spcgrno =  91
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P41212          ') then
	  cr_spcgrno =  92
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4222           ') then
	  cr_spcgrno =  93
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42212          ') then
	  cr_spcgrno =  94
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4322           ') then
	  cr_spcgrno =  95
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P43212          ') then
	  cr_spcgrno =  96
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I422            ') then
	  cr_spcgrno =  97
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I4122           ') then
	  cr_spcgrno =  98
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4mm            ') then
	  cr_spcgrno =  99
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4bm            ') then
	  cr_spcgrno = 100
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42cm           ') then
	  cr_spcgrno = 101
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42nm           ') then
	  cr_spcgrno = 102
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4cc            ') then
	  cr_spcgrno = 103
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4nc            ') then
	  cr_spcgrno = 104
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42mc           ') then
	  cr_spcgrno = 105
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42bc           ') then
	  cr_spcgrno = 106
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I4mm            ') then
	  cr_spcgrno = 107
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I4cm            ') then
	  cr_spcgrno = 108
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I41md           ') then
	  cr_spcgrno = 109
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I41cd           ') then
	  cr_spcgrno = 110
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-42m           ') then
	  cr_spcgrno = 111
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-42c           ') then
	  cr_spcgrno = 112
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-421m          ') then
	  cr_spcgrno = 113
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-421c          ') then
	  cr_spcgrno = 114
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-4m2           ') then
	  cr_spcgrno = 115
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-4c2           ') then
	  cr_spcgrno = 116
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-4b2           ') then
	  cr_spcgrno = 117
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P-4n2           ') then
	  cr_spcgrno = 118
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I-4m2           ') then
	  cr_spcgrno = 119
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I-4c2           ') then
	  cr_spcgrno = 120
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I-42m           ') then
	  cr_spcgrno = 121
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I-42d           ') then
	  cr_spcgrno = 122
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/mmm          ') then
	  cr_spcgrno = 123
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/mcc          ') then
	  cr_spcgrno = 124
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/nbm          ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 125
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 125
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 284
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P4/nnc          ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 126
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 126
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 285
	      cr_syst    =   5
	    else
	      ier_num = -7
	    ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P4/mbm          ') then
	  cr_spcgrno = 127
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/mnc          ') then
	  cr_spcgrno = 128
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P4/nmm          ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 129
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 129
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 286
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P4/ncc          ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 130
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 130
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 287
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P42/mmc         ') then
	  cr_spcgrno = 131
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42/mcm         ') then
	  cr_spcgrno = 132
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42/nbc         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 133
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 133
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 288
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P42/nnn         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 134
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 134
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 289
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P42/mbc         ') then
	  cr_spcgrno = 135
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42/mnm         ') then
	  cr_spcgrno = 136
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'P42/nmc         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 137
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 137
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 290
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P42/ncm         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 138
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 138
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 291
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'I4/mmm          ') then
	  cr_spcgrno = 139
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I4/mcm          ') then
	  cr_spcgrno = 140
	  cr_syst    =   5
	elseif(cr_spcgr.eq.'I41/amd         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 141
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 141
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 292
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'I41/acd         ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 142
	    cr_syst    =   5
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 142
	      cr_syst    =   5
	    elseif(ii.eq.2) then
	      cr_spcgrno = 293
	      cr_syst    =   5
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P3              ') then
	  cr_spcgrno = 143
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P31             ') then
	  cr_spcgrno = 144
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P32             ') then
	  cr_spcgrno = 145
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'R3              ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 146
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 294
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P-3             ') then
	  cr_spcgrno = 147
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'R-3             ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 148
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 295
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P312            ') then
	  cr_spcgrno = 149
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P321            ') then
	  cr_spcgrno = 150
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P3112           ') then
	  cr_spcgrno = 151
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P3121           ') then
	  cr_spcgrno = 152
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P3212           ') then
	  cr_spcgrno = 153
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P3221           ') then
	  cr_spcgrno = 154
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'R32             ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 155
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 296
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P3m1            ') then
	  cr_spcgrno = 156
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P31m            ') then
	  cr_spcgrno = 157
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P3c1            ') then
	  cr_spcgrno = 158
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P31c            ') then
	  cr_spcgrno = 159
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'R3m             ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 160
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 297
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'R3c             ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 161
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 298
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P-31m           ') then
	  cr_spcgrno = 162
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P-31c           ') then
	  cr_spcgrno = 163
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P-3m1           ') then
	  cr_spcgrno = 164
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'P-3c1           ') then
	  cr_spcgrno = 165
	  cr_syst    =   6
	elseif(cr_spcgr.eq.'R-3m            ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 166
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 299
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'R-3c            ') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    cr_spcgrno = 167
	  cr_syst    =   6
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	      cr_spcgrno = 300
	  cr_syst    =   7
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'P6              ') then
	  cr_spcgrno = 168
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P61             ') then
	  cr_spcgrno = 169
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P65             ') then
	  cr_spcgrno = 170
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P62             ') then
	  cr_spcgrno = 171
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P64             ') then
	  cr_spcgrno = 172
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63             ') then
	  cr_spcgrno = 173
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P-6             ') then
	  cr_spcgrno = 174
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6/m            ') then
	  cr_spcgrno = 175
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63/m           ') then
	  cr_spcgrno = 176
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P622            ') then
	  cr_spcgrno = 177
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6122           ') then
	  cr_spcgrno = 178
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6522           ') then
	  cr_spcgrno = 179
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6222           ') then
	  cr_spcgrno = 180
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6422           ') then
	  cr_spcgrno = 181
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6322           ') then
	  cr_spcgrno = 182
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6mm            ') then
	  cr_spcgrno = 183
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6cc            ') then
	  cr_spcgrno = 184
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63cm           ') then
	  cr_spcgrno = 185
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63mc           ') then
	  cr_spcgrno = 186
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P-6m2           ') then
	  cr_spcgrno = 187
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P-6c2           ') then
	  cr_spcgrno = 188
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P-62m           ') then
	  cr_spcgrno = 189
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P-62c           ') then
	  cr_spcgrno = 190
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6/mmm          ') then
	  cr_spcgrno = 191
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P6/mcc          ') then
	  cr_spcgrno = 192
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63/mcm         ') then
	  cr_spcgrno = 193
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P63/mmc         ') then
	  cr_spcgrno = 194
	  cr_syst    =   8
	elseif(cr_spcgr.eq.'P23             ') then
	  cr_spcgrno = 195
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'F23             ') then
	  cr_spcgrno = 196
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I23             ') then
	  cr_spcgrno = 197
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P213            ') then
	  cr_spcgrno = 198
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I213            ') then
	  cr_spcgrno = 199
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pm-3            ') then
	  cr_spcgrno = 200
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pn-3            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 201
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 201
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 301
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Fm-3            ') then
	  cr_spcgrno = 202
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Fd-3            ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 203
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 203
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 302
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Im-3            ') then
	  cr_spcgrno = 204
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pa-3            ') then
	  cr_spcgrno = 205
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Ia-3            ') then
	  cr_spcgrno = 206
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P432            ') then
	  cr_spcgrno = 207
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P4232           ') then
	  cr_spcgrno = 208
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'F432            ') then
	  cr_spcgrno = 209
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'F4132           ') then
	  cr_spcgrno = 210
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I432            ') then
	  cr_spcgrno = 211
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P4332           ') then
	  cr_spcgrno = 212
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P4132           ') then
	  cr_spcgrno = 213
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I4132           ') then
	  cr_spcgrno = 214
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P-43m           ') then
	  cr_spcgrno = 215
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'F-43m           ') then
	  cr_spcgrno = 216
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I-43m           ') then
	  cr_spcgrno = 217
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P-43n           ') then
	  cr_spcgrno = 218
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'F-43c           ') then
	  cr_spcgrno = 219
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'I-43d           ') then
	  cr_spcgrno = 220
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pm-3m           ') then
	  cr_spcgrno = 221
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pn-3n           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 222
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 222
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 303
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Pm-3n           ') then
	  cr_spcgrno = 223
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Pn-3m           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 224
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 224
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 304
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Fm-3m           ') then
	  cr_spcgrno = 225
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Fm-3c           ') then
	  cr_spcgrno = 226
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Fd-3m           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 227
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 227
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 305
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Fd-3c           ') then
	  if(ianz.eq.1) then
	    cr_spcgrno = 228
	    cr_syst    =   9
	  elseif(ianz.eq.2) then
	    if(ii.eq.1) then
	      cr_spcgrno = 228
	      cr_syst    =   9
	    elseif(ii.eq.2) then
	      cr_spcgrno = 306
	      cr_syst    =   9
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	elseif(cr_spcgr.eq.'Im-3m           ') then
	  cr_spcgrno = 229
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'Ia-3d           ') then
	  cr_spcgrno = 230
	  cr_syst    =   9
	elseif(cr_spcgr.eq.'P112            ') then
	  cr_spcgrno = 231
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P1121           ') then
	  cr_spcgrno = 232
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'A121            ') then
	  cr_spcgrno = 233
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'I121            ') then
	  cr_spcgrno = 234
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'A112            ') then
	  cr_spcgrno = 235
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'B112            ') then
	  cr_spcgrno = 236
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'I112            ') then
	  cr_spcgrno = 237
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P11m            ') then
	  cr_spcgrno = 238
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P1n1            ') then
	  cr_spcgrno = 239
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P1a1            ') then
	  cr_spcgrno = 240
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P11a            ') then
	  cr_spcgrno = 241
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P11n            ') then
	  cr_spcgrno = 242
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P11b            ') then
	  cr_spcgrno = 243
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'A1m1            ') then
	  cr_spcgrno = 244
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'I1m1            ') then
	  cr_spcgrno = 245
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'A11m            ') then
	  cr_spcgrno = 246
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'B11m            ') then
	  cr_spcgrno = 247
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'I11m            ') then
	  cr_spcgrno = 248
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'A1n1            ') then
	  cr_spcgrno = 249
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'I1a1            ') then
	  cr_spcgrno = 250
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'A11a            ') then
	  cr_spcgrno = 251
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'B11n            ') then
	  cr_spcgrno = 252
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'I11b            ') then
	  cr_spcgrno = 253
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P112/m          ') then
	  cr_spcgrno = 254
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P1121/m         ') then
	  cr_spcgrno = 255
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'A12/m1          ') then
	  cr_spcgrno = 256
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'I12/m1          ') then
	  cr_spcgrno = 257
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'A112/m          ') then
	  cr_spcgrno = 258
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'B112/m          ') then
	  cr_spcgrno = 259
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'I112/m          ') then
	  cr_spcgrno = 260
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P12/n1          ') then
	  cr_spcgrno = 261
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P12/a1          ') then
	  cr_spcgrno = 262
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P112/a          ') then
	  cr_spcgrno = 263
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P112/n          ') then
	  cr_spcgrno = 264
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P112/b          ') then
	  cr_spcgrno = 265
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P121/n1         ') then
	  cr_spcgrno = 266
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P121/a1         ') then
	  cr_spcgrno = 267
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'P1121/a         ') then
	  cr_spcgrno = 268
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P1121/n         ') then
	  cr_spcgrno = 269
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'P1121/b         ') then
	  cr_spcgrno = 270
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'A12/n1          ') then
	  cr_spcgrno = 271
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'I12/a1          ') then
	  cr_spcgrno = 272
	  cr_syst    =   2
	elseif(cr_spcgr.eq.'A112/a          ') then
	  cr_spcgrno = 273
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'B112/n          ') then
	  cr_spcgrno = 274
	  cr_syst    =   3
	elseif(cr_spcgr.eq.'I112/b          ') then
	  cr_spcgrno = 275
	  cr_syst    =   3
	else
	  cr_spcgrno =   0
	  cr_syst    =   0
	  ier_num        =  -7
	  ier_typ = ER_APPL
	endif
	if(ier_num.eq.0) then
	    ier_num = -14
	    ier_typ = ER_APPL
	  if    (cr_syst.eq.1) then
	      ier_num = 0
	      ier_typ = ER_NONE
	  elseif(cr_syst.eq.2) then
	    if(cr_win(1).eq.90.0     .and. cr_win(3).eq.90.0) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.3) then
	    if(cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.4) then
	    if(cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.5) then
	    if(cr_a0 (1).eq.cr_a0(2) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.6 .or. cr_syst.eq.8) then
	    if(cr_a0 (1).eq.cr_a0(2) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.120.0                           ) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.7) then
	    if(cr_a0 (1).eq.cr_a0(2) .and. cr_a0 (1).eq.cr_a0(3) .and.
     &	       cr_win(1).eq.cr_win(2).and. cr_win(2).eq.cr_win(3)) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  elseif(cr_syst.eq.9) then
	    if(cr_a0 (1).eq.cr_a0(2) .and. cr_a0 (1).eq.cr_a0(3) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      ier_num = 0
	      ier_typ = ER_NONE
	    endif
	  endif
	endif
	end
c**********************************************************************
	subroutine symmetry
c-
c	Performs the space group symmetry on the current atom.
c	cr_natoms             the current atom number 
c	cr_iscat(cr_natoms)   its scattering type
c	                      and thus number of chemically identical
c	                      yet symmetrically different atoms
c
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	real           	x(4),y(4),xmat(4,4),wmat(4,4),eps
	integer       	i,j,k,ii,iii,igs,igg,ipg,ia,iaa
c
	include 	'generate.inc'
c
	data           eps/0.00001/
c
c------	ii is the number of the atom the symmetry is to work on
c
	ii = cr_natoms
c
c------	Loop over all generators for spacegroup cr_spcgrno
c
	do igs = 1,generspcgr(0,cr_spcgrno)
	  igg = generspcgr(igs,cr_spcgrno)
c
c------	--iii is the number of the last atom generated by the previous
c------	--generator
c
	  iii = cr_natoms
c
c------	--For convenience create Identity operator
c
	  do i = 1,4
	    do j = 1,4
	      xmat(i,j)=0.0
	    enddo
	    xmat(i,i)=1.0
	  enddo
c
c------	--Loop over all powers of generator igg
c
	  do ipg = 1,generpower(igg)
c
c------	----raise power of generator, xmat is a dummy matrix, equal to
c------	----the previous power of the generator
c
	    do i = 1,4
	      do j = 1,4
	        wmat(i,j)=0.0
	        do k = 1,4
	          wmat(i,j)=wmat(i,j)+generators(i,k,igg)*xmat(k,j)
	        enddo
	      enddo
	    enddo
c
c------	----Multiply first point with current generator
c
	    do i=1,3
	      x(i)=cr_pos(i,ii)
	    enddo
	    x(4)=1.0
	    call trans(x,wmat,y,4)
	    call firstcell(y,4)
c
c------	----check for existence with all previously created atoms
c 
	    do ia=ii,iii
c------	------if atom exists, skip generator
	      if( abs(y(1)-cr_pos(1,ia)).lt. eps .and. 
     &	          abs(y(2)-cr_pos(2,ia)).lt. eps .and. 
     &	          abs(y(3)-cr_pos(3,ia)).lt. eps       ) goto 10
	    enddo
c
c------	----insert atom into crystal
c
	    if(cr_natoms.lt.nmax) then
	      cr_natoms = cr_natoms+1
	      cr_pos(1,cr_natoms) = y(1)
	      cr_pos(2,cr_natoms) = y(2)
	      cr_pos(3,cr_natoms) = y(3)
	      cr_iscat(cr_natoms) = cr_iscat(ii)
	    else
	      ier_num = -10
	      ier_typ = ER_APPL
	      write (ier_msg(1),8888) nmax
8888	      format('Maximum allowed atom number =',i10) 
	      return
	    endif
c
c------	----Multiply all other points with current generator
c
	    do iaa = ii+1,iii
	      do i=1,3
	        x(i)=cr_pos(i,iaa)
	      enddo
	      x(4)=1.0
	      call trans(x,wmat,y,4)
	      call firstcell(y,4)
c
c------	--------insert atom into crystal
c
	      if(cr_natoms.lt.nmax) then
	        cr_natoms = cr_natoms+1
	        cr_pos(1,cr_natoms) = y(1)
	        cr_pos(2,cr_natoms) = y(2)
	        cr_pos(3,cr_natoms) = y(3)
	        cr_iscat(cr_natoms) = cr_iscat(ii)
	      else
	        ier_num = 10
	        ier_typ = ER_APPL
	        return
	      endif
	    enddo
c
c------	--set xmat to current power of generator
c
	    do i = 1,4
	      do j = 1,4
	        xmat(i,j)=wmat(i,j)
	      enddo
	    enddo
c------	----End of loop over all powers
	  enddo
10	  continue
c------	--end of loop over all generators
	enddo
3000    format(3(e12.5e1,','),e12.5e1)
	end
c**********************************************************************
	subroutine firstcell(y,idim)
c-
c	truncates atomic position to fractal position of 
c	0.0 <= x < 1
c+
	implicit      none
c
	integer       idim,i
	real          y(idim)
c
	do i = 1,3
	  y(i) = y(i) - float(int(y(i)))
	  if(y(i) .lt. 0.0) y(i) = y(i)+1
	  if(y(i) .eq. 1.0) y(i) = 0.0
	enddo
	end
c**********************************************************************
	subroutine rese_cr
c
c	resets the crystal structure to empty
c
	implicit 	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
c
	integer 	i
c
	cr_natoms  = 0
	as_natoms  = 0
	cr_ncatoms = 0
	cr_nscat   = 0
	do i=1,maxscat
	  cr_at_lis(i) = ' '
	enddo
c
	end
c**********************************************************************
	subroutine recip_symm
c-
c	Creates the symmetry matrices in reciprocal space
c+
	implicit   none
c
	include    'config.inc'
	include    'crystal.inc'
	include    'crystal.cmm'
	include    'recipro.inc'
c
	integer    i,j,k
	logical    lfriedel_remove
	logical    lacentric
	real       a(3,3)
	real       b(3,3)
	real       h(4,rec_max_sym)
c
c------	Set up a general reflection
c
	h(1,1) = 0.1
	h(2,1) = 0.2
	h(3,1) = 0.3
	h(4,1) = 0.0
	do i=1,4
	  do j=1,4
	    rec_sym(i,j,1) = 0.0
	  enddo
	  rec_sym(i,i,1) = 1.0
	enddo
c
c------	Create all symmetry operations in real space that create
c	a different vector, ignoring the translational part. The
c	translational part of each first new matrix is saved, since
c	this is needed for proper phase assignment.
c	lfriedel_remove  Logical variable that signals to remove
c	                 symmetry operations -1
c	cr_acentric      logical variable that describes whether the
c	                 space group is acentric or not
c
	lfriedel_remove = .false.
	call rmc_symmetry (rec_n_sym,h,rec_sym,rec_max_sym,
     &	                   lfriedel_remove,lacentric)
	cr_acentric = lacentric
c
c------	Transform all symmetry operations into reciprocal space
c
	do k=1,rec_n_sym
	  do i=1,3
	    do j=1,3
	      a(i,j) = rec_sym(i,j,k)
	    enddo
	  enddo
c
c------	--do transformation q = gSg*
c
	  call matmul (b,a,cr_rten)
	  call matmul (a,cr_gten,b)
	  do i=1,3
	    do j=1,3
	      rec_sym(i,j,k) = a(i,j)
	    enddo
	  enddo
c
cdbg	write( *,1000) k
cdbg	do i=1,4
cdbg	  write(*,1010) (rec_sym(i,j,k),j=1,4)
cdbg	enddo
cdbg1000	format('**********************'/' Matrix Number ', i4)
cdbg1010	format(3(f4.1,2x),f7.4)
	enddo
c
	end
c*****7****************************************************************
	subroutine update_cr_dim
c-
c	Updates the crystal dimensions to the current values
c+
	implicit   none
c
	include    'config.inc'
	include    'crystal.inc'
	include    'crystal.cmm'
c
	integer    i,j
c
c------	Set initial values
c
	if(cr_natoms.gt.0) then
	  do j=1,3
	    cr_dim(j,1) = cr_pos(j,1)
	    cr_dim(j,2) = cr_pos(j,2)
	  enddo
	else
	  do j=1,3
	    cr_dim(j,1) =  1.e10
	    cr_dim(j,1) = -1.e10
	  enddo
	endif
c
c------	Update values from all atoms in crystal
c
	do i=1,cr_natoms
	  do j=1,3
            cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
            cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	  enddo
	enddo
c
	end
c*****7****************************************************************
