c*****7*****************************************************************
	subroutine mache_kdo(line,lend,length)
c+
c	This routine interprets the commands and executes the 
c	corresponding function.
c
c	Version : 1.0
c	Date    : 10 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c-
	implicit     none
c
	include      'kuplot.inc'
	include      'learn.inc'
	include      'errlist.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*200 line,zei,cpara(maxw)
	character*70  command
	character*4   bef
	integer       lpara(maxw)
	integer       lc,lbef,length
	integer       ianz,indxg,indxb
	logical       lend
c
	integer       len_str
	logical       str_comp
c
	save          command
c
	call no_error
c
c------ If a commentary return immediately
c
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#' .or. 
     &	   line(1:1).eq.'!' .or. length.eq.0           ) return
c
c------	Only the first 4 characters are significant. The command consists
c	of the four nonblank characters 
c
	bef = '    '
	indxb  = index(line,' ')
	lbef   = min(indxb-1,4)
	bef = line(1:lbef )
c
c------	command parameters start at the first character following the blank
c
	zei = ' '
	lc = 0
	if(indxb+1.le.length) then
	  zei = line(indxb+1:length)
	  lc = length - indxb
	endif
c
c-------Suche nach einem "="
c
	indxg=index(line,'=')
        if(indxg.ne.0.and..not.(str_comp(bef,'echo',2,lbef,4))
     &               .and..not.(str_comp(bef,'syst',2,lbef,4))
     &               .and..not.(str_comp(bef,'achx',2,lbef,4))
     &               .and..not.(str_comp(bef,'achy',2,lbef,4))
     &               .and..not.(str_comp(bef,'tit1',2,lbef,4))
     &               .and..not.(str_comp(bef,'tit2',2,lbef,4))
     &               .and..not.(str_comp(bef,'help',2,lbef,4) .or.
     &	                        str_comp(bef,'?   ',2,lbef,4)) )then
c
c-------Zuweisung eines Funktionswertes
c
	  call do_math(line,indxg,length)
	else
c
c------	--execute a macro file
c
	  if(bef(1:1).eq.'@') then
	    if(length.ge.2) then
	      call file_kdo(line(2:length),length-1)
	    else
	      ier_num = -13
	      ier_typ = ER_MAC
	    endif
c
c------	continues a macro 'continue'
c
	  elseif(str_comp(bef,'continue',2,lbef,8)) then
	    call macro_continue(zei,lc)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	  elseif(str_comp(bef,'echo',2,lbef,4)) then
            write(*,'(1x,a)') zei(1:len_str(zei))
c
c------	Evaluate an expression, just for interactive check 'eval'
c
	  elseif(str_comp(bef,'eval',2,lbef,4)) then
	    call do_eval(zei,lc)
c
c------ Terminate KUPLOT 'exit'
c
	  elseif(str_comp(bef,'exit',2,lbef,4)) then
	    lend=.true.
c
c------ Online help
c
	  elseif(str_comp(bef,'help',2,lbef,4) .or.
     &	         str_comp(bef,'?   ',1,lbef,4)     ) then
	    lc = lc + 7
            call do_hel('kuplot '//zei,lc)
c
c-------  start learning a macro 'learn'
c
	  elseif(str_comp(bef,'lear',3,lbef,4)) then
	    call start_learn(zei,lc)
c
c-------  end learning a macro 'lend'
c
	  elseif(str_comp(bef,'lend',3,lbef,4)) then
	    call ende_learn	  
c
c-------  Various settings 'set'
c
	  elseif(str_comp(bef,'set',3,lbef,3)) then
	    call do_set(zei,lc)
c
c-------  Operating System Kommandos 'syst'
c
	  elseif(str_comp(bef,'syst',2,lbef,4)) then
	    command=' '
	    if(zei.ne. ' ') then
	      command(1:lc)=zei(1:lc)
	      call do_operating(command)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c-------  Wait for user input 'wait'
c
	  elseif(str_comp(bef,'wait',3,lbef,4)) then
	    call do_input(zei,lc)
c
c-------  Start of KUPLOT specific commands
c-------  Allocate memory for new dataset 
c
	  elseif(str_comp(bef,'allocate',2,lbef,8)) then
	    call do_allocate(zei,lc)
c
c-------  Perform calculations
c
	  elseif(str_comp(bef,'ccal',3,lbef,4)) then
	    call do_calc(zei,lc)
	  elseif(str_comp(bef,'kcal',3,lbef,4)) then
	    call do_kmath(zei,lc)
c
c-------  Set bitmap colormap
c
	  elseif(str_comp(bef,'cmap',3,lbef,4)) then
	    call set_cmap(zei,lc)
c
c-------  Enter fit sublevel
c
	  elseif(str_comp(bef,'fit',3,lbef,3)) then
	    call do_fit(zei,lc)
c
c-------  Plot filenames on plot
c
	  elseif(str_comp(bef,'fnam',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    ifname(iframe)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  Set typ of box & axis
c
	  elseif(str_comp(bef,'fset',3,lbef,4)) then
	    call set_ibox(zei,lc)
c
c-------  Set font size, type and color
c
	  elseif(str_comp(bef,'font',3,lbef,4)) then
	    call set_font(zei,lc)
c
c-------  Plot frame around plot/frames
c
	  elseif(str_comp(bef,'fram',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    tot_frame=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  smooth data 'glat'
c
	  elseif(str_comp(bef,'glat',2,lbef,4)) then
	    call do_glat(zei,lc)
c
c-------  grid on/off
c
	  elseif(str_comp(bef,'grid',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    igrid(iframe)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  set contour line parameters
c
	  elseif(str_comp(bef,'hlin',3,lbef,4)) then
	    call set_hlin(zei,lc)
	  elseif(str_comp(bef,'hcol',3,lbef,4)) then
	    call para_setii(zei,lc,hlinecol,maxkurvtot,maxhl,bef,1,6)
	  elseif(str_comp(bef,'htyp',3,lbef,4)) then
	    call para_setii(zei,lc,hlinetyp,maxkurvtot,maxhl,bef,0,6)
	  elseif(str_comp(bef,'hpak',3,lbef,4)) then
	    call set_hpak(zei,lc)
c
c-------  calculate integral
c
	  elseif(str_comp(bef,'inte',2,lbef,4)) then
	    call do_inte(zei,lc)
c
c-------  show coordinates
c
	  elseif(str_comp(bef,'koor',2,lbef,4)) then
	    call do_koor
c
c-------  save data set
c
	  elseif(str_comp(bef,'ksav',2,lbef,4)) then
	    call do_ksav(zei,lc)
c
c-------  set max. number of data sets
c
	  elseif(str_comp(bef,'kurv',2,lbef,4)) then
	    call do_kurv(zei,lc)
c
c-------  Load files 'load'
c
	  elseif(str_comp(bef,'load',2,lbef,4)) then
	    call do_load(zei,lc)
c
c-------  Set line width
c
	  elseif(str_comp(bef,'lwid',2,lbef,4)) then
	    call set_linewidth(zei,lc)
c
c-------  Set tick marks
c
	  elseif(str_comp(bef,'mark',3,lbef,4)) then
	    call set_mark(zei,lc)
c
c-------  Calculate averages, ..
c
	  elseif(str_comp(bef,'mean',3,lbef,4)) then
	    call do_mean(zei,lc,.true.)
c
c-------  Set marker size
c
	  elseif(str_comp(bef,'msize',2,lbef,5)) then
	    call set_sizemark(zei,lc)
c
c-------  set landscape / portrait orientation
c
	  elseif(str_comp(bef,'orient',3,lbef,6)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    orient=str_comp(cpara(1),'landscape',1,lpara(1),9)
c
c-------  Here are all frame related commands: nfra,afra,kfra,...
c
	  elseif(str_comp(bef,'nfra',2,lbef,4)) then
	    call set_nfra(zei,lc)
	  elseif(str_comp(bef,'kfra',2,lbef,4)) then
	    call set_kfra(zei,lc)
	  elseif(str_comp(bef,'sfra',2,lbef,4)) then
	    call set_sfra(zei,lc)
	  elseif(str_comp(bef,'afra',2,lbef,4)) then
	    call set_afra(zei,lc)
	  elseif(str_comp(bef,'cfra',2,lbef,4)) then
	    call set_cfra(zei,lc)
	  elseif(str_comp(bef,'bfra',2,lbef,4)) then
	    call set_bfra(zei,lc)
c
c-------  Plot, save or print graphic
c
	  elseif(str_comp(bef,'plot',2,lbef,4) .or.
     &	         str_comp(bef,'save',2,lbef,4) .or.
     &	         str_comp(bef,'prin',2,lbef,4)     ) then
	    call do_plot (bef,zei,lbef,lc)
c
c-------  Commands 'achx','achy','tit1' and 'tit2'
c
	  elseif(str_comp(bef,'achx',4,lbef,4)) then
	    call para_setc(zei,lc,achse(iframe,1))
	  elseif(str_comp(bef,'achy',4,lbef,4)) then
	    call para_setc(zei,lc,achse(iframe,2))
	  elseif(str_comp(bef,'tit1',4,lbef,4)) then
	    call para_setc(zei,lc,titel(iframe,1))
	  elseif(str_comp(bef,'tit2',4,lbef,4)) then
	    call para_setc(zei,lc,titel(iframe,2))
c
c-------  Commands 'mass','aver',...
c
	  elseif(str_comp(bef,'aver',3,lbef,4)) then
	    call para_setr(zei,lc,yskal(iframe),bef,-9999.)
	  elseif(str_comp(bef,'mass',3,lbef,4)) then
	    call para_setr(zei,lc,plmass(iframe),bef,-9999.)
	  elseif(str_comp(bef,'angle',3,lbef,5)) then
	    call para_setr(zei,lc,shear(iframe),bef,90.0)
	    if(ier_num.eq.0) plmass(iframe)=-9999.0
c
c-------  Commands 'ltyp','lcol','mtyp','mcol',...
c
	  elseif(str_comp(bef,'ltyp',4,lbef,4)) then
	    call para_seti(zei,lc,ilinetyp,1,maxkurvtot,bef,0,6,.false.)
	  elseif(str_comp(bef,'mtyp',4,lbef,4)) then
	    call para_seti(zei,lc,imarktyp,1,maxkurvtot,bef,0,10,.false.)
	  elseif(str_comp(bef,'lcol',4,lbef,4)) then
	    call para_seti(zei,lc,ilinecol,0,maxkurvtot,bef,1,6,.true.)
	  elseif(str_comp(bef,'mcol',4,lbef,4)) then
	    call para_seti(zei,lc,imarkcol,1,maxkurvtot,bef,1,6,.false.)
	  elseif(str_comp(bef,'lart',4,lbef,4)) then
	    call para_seti(zei,lc,ilineart,1,maxkurvtot,bef,1,3,.false.)
	  elseif(str_comp(bef,'hart',4,lbef,4)) then
	    call para_seti(zei,lc,hlineart,1,maxkurvtot,bef,1,3,.false.)
	  elseif(str_comp(bef,'ptyp',4,lbef,4)) then
	    call para_seti(zei,lc,imarkmax,1,maxkurvtot,bef,0,10,.false.)
	  elseif(str_comp(bef,'etyp',4,lbef,4)) then
	    call para_seti(zei,lc,ierr    ,1,maxkurvtot,bef,0,3,.false.)
c
c-------  Reset
c
	  elseif(str_comp(bef,'rese',3,lbef,4)) then
	    call do_rese
c
c-------  Set annotations
c
	  elseif(str_comp(bef,'sann',3,lbef,4)) then
	    call set_annotation(zei,lc)
c
c-------  Set screen device
c
	  elseif(str_comp(bef,'screen',3,lbef,6)) then
	    call do_screen(zei,lc)
c
c-------  Read/Write defaults
c
	  elseif(str_comp(bef,'sdef',3,lbef,4)) then
	    call do_write_def(zei,lc)
	  elseif(str_comp(bef,'rdef',3,lbef,4)) then
	    call do_read_def(zei,lc)
c
c-------  Show parameters 'show'
c
	  elseif(str_comp(bef,'show',3,lbef,4)) then
	    call do_show(zei,lc)
c
c-------  Set data set caption
c
	  elseif(str_comp(bef,'sleg',3,lbef,4)) then
	    call set_legend(zei,lc)
c
c-------  Set plotting window
c
	  elseif(str_comp(bef,'skal',3,lbef,4)) then
	    call set_skal(zei,lc)
c
c-------  Sort data set (up in x)
c
	  elseif(str_comp(bef,'sort',3,lbef,4)) then
	    call do_sort(zei,lc)
c
c-------  Search maxima
c
	  elseif(str_comp(bef,'smax',3,lbef,4)) then
	    call do_smax(zei,lc)
c
c-------  Define background using the mouse
c
	  elseif(str_comp(bef,'unter',3,lbef,5)) then
	    call do_unter(zei,lc)
c
c-------  Define excluded regions using the mouse
c
	  elseif(str_comp(bef,'wgeb',3,lbef,4)) then
	    call do_wg(zei,lc)
c
c-------  Set X11 window width in pixels
c
	  elseif(str_comp(bef,'xwidth',3,lbef,6)) then
	    call set_xscreen(zei,lc)
c
c-------  Unknown command
c
	  else
	    ier_num = -8
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
