c*****7*****************************************************************
c
c	This include file contains all common variables for the
c	plotting routines of KUPL.
c
c	Version : 1.0
c	Date    : 10 Oct 96
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c
c*****7*****************************************************************
c
c	The following variables need to be adjusted for the user
c	requirements.
c
c
c	maxarray   : Defines the total number of points KUPL can read
c	maxkurvtot : Defines the maximum number of different data sets
c	maxpara    : Defines the maximum number of parameters for fitting
c	maxhl      : Defines the maximum number of contour line sets
c	maxframe   : Defines the maximum number of frames
c	maxsp      : Defines the maximum number of points for spline/steps
c	maxan      : Defines the maximum number of annotations
c	maxcol     : Defines the maximum number of bitmap colours
c	             (15 colours for line/frame/background/...)
c-
	integer		maxpara,maxkurvtot,maxarray,maxhl
	integer		maxframe,maxsp,maxan,maxcol
c
	parameter	(maxpara    = 100)
	parameter	(maxkurvtot = 10)
	parameter	(maxarray   = 350000)
	parameter	(maxhl      = 5)
	parameter	(maxframe   = 10)
	parameter	(maxsp      = 100)
	parameter	(maxan      = 10)
	parameter	(maxcol     = 240)
c
	integer		hpgl,tek,x11,ps
c
	parameter	(hpgl       = 1)
	parameter	(tek        = 2)
	parameter	(x11	    = 3)
	parameter  	(ps         = 4)
c
	integer		fid_times,    fid_courier   
	integer		fid_symbol,   fid_helvetica
	integer		fid_times_b,  fid_courier_b 
	integer		fid_symbol_b, fid_helvetica_b
	integer		fid_times_i,  fid_courier_i
	integer		fid_symbol_i, fid_helvetica_i
	integer		fid_times_ib, fid_courier_ib
	integer		fid_symbol_ib,fid_helvetica_ib
c
	parameter	(fid_times        = 1 )
	parameter	(fid_courier      = 2 )
	parameter	(fid_symbol       = 3 )
	parameter	(fid_helvetica    = 4 )
	parameter	(fid_times_b      = 5 )
	parameter	(fid_courier_b    = 6 )
	parameter	(fid_symbol_b     = 7 )
	parameter	(fid_helvetica_b  = 8 )
	parameter	(fid_times_i      = 9 )
	parameter	(fid_courier_i    = 10)
	parameter	(fid_symbol_i     = 11)
	parameter	(fid_helvetica_i  = 12)
	parameter	(fid_times_ib     = 13)
	parameter	(fid_courier_ib   = 14)
	parameter	(fid_symbol_ib    = 15)
	parameter	(fid_helvetica_ib = 16)
c
	integer		if_left,if_centre,if_right
c
	parameter	(if_left       = 1)
	parameter	(if_centre     = 2)
	parameter	(if_right      = 3)
c
c------ Device handling
c
	character*80	prnps,prnhpgl
	integer		id_dev,id_dev_screen,id_dev_hardcopy
	integer		itek_typ
c
	common	/dev/	id_dev,id_dev_screen,id_dev_hardcopy,itek_typ,
     &			prnps, prnhpgl
c
c------ Data set information
c
	character*40	fname(maxkurvtot)
	character*2	fform(maxkurvtot)
	real		xmax(maxkurvtot),xmin(maxkurvtot)
	real		ymax(maxkurvtot),ymin(maxkurvtot) 
	integer		len(maxkurvtot)
	integer		iz
c
	common	/info/  fname,fform,xmax,xmin,ymax,ymin,len,iz
c
c------ Plot area information
c
	real		frame(maxframe,4)
	real		wxmin,wxmax,wymin,wymax
	integer		iframe,iaf
c
      	common	/area/ 	wxmin,wxmax,wymin,wymax,frame,iframe,iaf
c
c------ Plotting parameters
c
	character*80	titel(maxframe,2)
	character*60	achse(maxframe,2)
	character*40	ftext(maxframe)
	character*40	clegend(maxkurvtot)
	character*40	antext(maxframe,maxan)
	real		ex(maxframe,2),ey(maxframe,2)
	real		t (maxframe,2),t0(maxframe,2)
	real		plmass(maxframe),yskal(maxframe)
	real		anx(maxframe,maxan),any(maxframe,maxan)
	integer		anjust(maxframe,maxan)
	integer		ilegend(maxkurvtot)
	integer		infra(maxframe,maxkurvtot)
	integer		ibox(maxframe)
	logical		igrid(maxframe)
	logical		orient
c
      	common	/plpar/	ibox,igrid,ilegend,infra,ex,ey,t,t0,plmass,yskal,
     &		 	orient,anx,any,anjust,achse,titel,clegend,ftext,
     &	                antext
c
c------ Plotting style parameters
c
	real		sizemark(maxkurvtot)
	real		linewid(0:maxkurvtot)
	real		fonsize (maxframe,10)
	real		frback(maxframe,3)
 	integer		ilinecol(0:maxkurvtot),imarkcol(maxkurvtot)
 	integer		ilinetyp(maxkurvtot),imarktyp(maxkurvtot)
	integer		ilineart(maxkurvtot),imarkmax(maxkurvtot)
	integer		ierr(maxkurvtot)
	integer		frjust(maxframe)
	integer		fon_id (maxframe,10)
	integer		foncol (maxframe,10)
	integer		ifen
	logical		ifname(maxframe) 
	logical		tot_frame
c
      	common	/plwer/	ilinecol,imarkcol,ierr,ilinetyp,imarktyp,
     &		 	ifen,ilineart,imarkmax,ifname,sizemark,
     &	                linewid,fonsize,fon_id,tot_frame,foncol,
     &	 		frjust,frback
c
c------ 3D data set information
c
	real		zmax(maxkurvtot),zmin(maxkurvtot) 
	real		z_min(maxframe,maxhl),z_inc(maxframe,maxhl)
	real		pgmlow,pgmhigh
	integer		nx(maxkurvtot),ny(maxkurvtot)
	integer		nz(maxframe,maxhl)
	integer		iho(maxkurvtot)
	integer		hlinecol(maxkurvtot,maxhl)
	integer		hlinetyp(maxkurvtot,maxhl)
	integer		hlineart(maxkurvtot)
	logical		lni(maxkurvtot)
c
	common	/nipl/	lni,iho,nz,z_min,z_inc,nx,ny,zmin,zmax,
     &	                hlinecol,hlinetyp,hlineart,pgmlow,pgmhigh
c
c------ Parameter frame 
c
	character*40	fpara
	integer		ipara,ilength,iwidth
c
	common	/para/	ipara,fpara,ilength,iwidth
c
c------ Scaling factors etc ..
c
	real		shear(maxframe)
	real		xnull,ynull
	real		fakx,faky
	real		charhx,charhy
	real		shiftx,shifty
	logical		sfl(maxframe)
c
	common	/abb/	xnull,ynull,fakx,faky,charhx,charhy,shear,sfl,
     &			shiftx,shifty
c
c------ Fit parameters
c
	character*4	ftyp
	character*3	wtyp
	real		w(maxarray)
	real		p(maxpara),pinc(maxpara),dp(maxpara)
	real		p_merk(maxpara),pinc_merk(maxpara)
	real		cl(maxpara,maxpara)
	real		urf
	real		zalt,zwert,zdif
	real		r4,re,fend
	integer		ncycle,npara,ikfit,ikcal,ikdif
	integer		np1,np2,np3
	logical		fstart,ikfirst
c
	common	/fit/	w,p,dp,pinc,cl,urf,ncycle,npara,np1,np2,np3,
     &	                zalt,zwert,zdif,fend,r4,re,fstart,p_merk,
     &	                pinc_merk,ikfit,ikcal,ikdif,ikfirst,
     &	                wtyp,ftyp
c
c------ Data
c
	real		x(maxarray),dx(maxarray)
	real		y(maxarray),dy(maxarray)
	real		z(maxarray)
	integer		maxkurv,maxpkt
c
	common	/data/	x,y,z,dx,dy,maxkurv,maxpkt
c
c------ Colormaps & X11 parameters
c
	real		col_map(maxcol,3)
	integer		col_typ
	integer		ix_new,iy_new,iscr_width
c
	common	/x11/	col_map,col_typ,ix_new,iy_new,iscr_width
c
