c*****7*****************************************************************
	subroutine init_tek 
c+
c	initialisieren des tek-schirms, berechnen der abbildungsfaktoren
c-
	implicit	none
c
	include		'kuplot.inc'
c
	call tekinit
c
	end
c*****7*****************************************************************
	subroutine open_tek 
c+
c	initialisieren des tek-schirms, berechnen der abbildungsfaktoren
c-
	implicit	none
c
	include		'kuplot.inc'
c
	fakx   = (frame(iframe,3)-frame(iframe,1))*1023./(wxmax-wxmin)
	faky   = (frame(iframe,4)-frame(iframe,2))* 779./(wymax-wymin)
	shiftx = frame(iframe,1) * 1023.
	shifty = frame(iframe,2) *  779.
	xnull  = wxmin
	ynull  = wymin
	charhx =   12. / fakx
	charhy =   21. / faky
c
	end
c*****7*****************************************************************
	subroutine close_tek 
c+
c	alles zu ende
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*1	wait
c
	call tekexit
        write(*,*) char(27)//char(3)
	read (*,1000)     wait
	write(*,*) char(24)
c
1000	format (a)
	end
c*****7*****************************************************************
	subroutine col_tek (icol) 
c+
c	setzen der farbe
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		icol
c
	if (itek_typ.eq.1) call tekcolkerm  (icol)
	if (itek_typ.eq.2) call tekcolxterm (icol)
c
	end
c*****7*****************************************************************
	subroutine ltyp_tek (ityp) 
c+
c	setzen linienattribut
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		ityp
c
	if (itek_typ.eq.1) call tekltyp (ityp)
c
	end
c*****7*****************************************************************
	subroutine lwidth_tek (lwidth) 
c+
c	setzen linienbreite (geht unter tek4014 nicht)
c-
	implicit	none
c
	real		lwidth
	end
c*****7*****************************************************************
	subroutine fsize_tek (fsize) 
c+
c	setzen fontgroesse (geht unter tek4014 nicht)
c-
	implicit	none
c
	real		fsize
	end
c*****7*****************************************************************
	subroutine text_tek (xp,yp,text,jmode)
c+
c	zeichnen von text
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*(*)	text
	character*80	dummy
	real		xp,yp,xpp,ypp,sh
	integer		i,ill,jmode,il,ix,iy
	integer		cfeld(132)
c
	integer		len_str
c
	dummy=text	
	il = len_str(dummy)
c
	if (jmode.gt.0) then
	  if (jmode.eq.if_left) then
	    xp=xp
	    yp=yp
	  elseif (jmode.eq.if_right) then
	    xp=xp-il*charhx
	    yp=yp
	  elseif (jmode.eq.if_centre) then
	    xp=xp-(il/2)*charhx
	    yp=yp
	  endif
	  ix = nint((xp - xnull) * fakx + shiftx)
	  iy = nint((yp - ynull) * faky + shifty)
	  do i=1,il
	    cfeld(i)=ichar(dummy(i:i))
	  enddo
	  call tekgraph
	  call tekvector (ix,iy)
	  if (il.gt.0) call tektext (cfeld,il)
	  xp=charhx*il
	else
	  sh = (il-1)*charhy
	  if (jmode.eq.-if_left) then
	    sh = 0
	  elseif (jmode.eq.-if_right) then
	    sh = -sh/2.
	  elseif (jmode.eq.-if_centre) then
	    sh = -sh
	  endif
	  ill=1
	  xpp=xp-0.5*charhx
	  do i=1,il
	    ypp=yp+(i-1)*charhy+sh
	    ix = nint((xpp - xnull) * fakx + shiftx)
            iy = nint((ypp - ynull) * faky + shifty)
            cfeld(1)=ichar(dummy(i:i))
            call tekgraph
            call tekvector (ix,iy)
	    call tektext (cfeld,ill)
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine pline_tek (npkt,xa,ya)
c+
c	polyline ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt,ix,iy,i
	real		xa(npkt),ya(npkt)
c
	call tekgraph
	do i=1,npkt
	  ix = nint((xa(i)-xnull)*fakx + shiftx)
	  iy = nint((ya(i)-ynull)*faky + shifty)
	  call tekvector (ix,iy)
	enddo
c
	end
c*****7*****************************************************************
	subroutine rect_tek (xlu,ylu,xro,yro,fill)
c+
c       rechteck zeichnen
c-
	implicit	none
c
	real		xlu,ylu,xro,yro
	real 		xp(5),yp(5)
	logical 	fill
c
	xp(1)=xlu
	yp(1)=ylu
	xp(2)=xro
	yp(2)=ylu
	xp(3)=xro
	yp(3)=yro
	xp(4)=xlu
	yp(4)=yro
	xp(5)=xlu
	yp(5)=ylu
	call pline_tek (5,xp,yp)
c
	end
c*****7*****************************************************************
	subroutine area_tek (npkt,xpp,ypp,fill)
c+
c       area border zeichnen
c-
	implicit	none
c
	integer		npkt
	real		xpp(npkt),ypp(npkt)
	logical 	fill
c
	real 		xp(5),yp(5)
	integer		i
c
	do i=1,npkt
	  xp(i)=xpp(i)
	  yp(i)=ypp(i)
	enddo
	xp(5)=xpp(1)
	yp(5)=ypp(1)
c
	call pline_tek (5,xp,yp)
c
	end
c*****7*****************************************************************
	subroutine circ_tek (px,py,delx,dely,fill)
c+
c       Kreis zeichnen
c-
	implicit	none
c
	real		px,py,delx,dely
	real 		xp(36),yp(36)
	integer		inc
	logical 	fill
c
	real		sind,cosd
c
	do inc=1,36
          xp(inc)=px+delx*sind(inc*10.0)
	  yp(inc)=py+dely*cosd(inc*10.0)
	enddo
	call pline_kupl (36,xp,yp)
c
	end
c*****7*****************************************************************
	subroutine in_tek (wx,wy,key)
c+
c	eingabe per fadenkreuz 
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*6	buffer
	character*1	key
	integer		ix,iy
	real		wx,wy
c
	call tekin (buffer)
c
	key = buffer(1:1)
	ix  = (ichar(buffer(2:2)) - 32) * 32
     & 	    + (ichar(buffer(3:3)) - 32)
	iy  = (ichar(buffer(4:4)) - 32) * 32
     &	    + (ichar(buffer(5:5)) - 32)
c
	wx  = ((ix-shiftx)/fakx) + xnull
	wy  = ((iy-shifty)/faky) + ynull
c
	end
