c****7******************************************************************
	subroutine init_x11 
c+
c	initialisieren des x11-schirms, berechnen der abbildungsfaktoren
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		ratio
	integer		i
	integer		bcol,r(maxcol),g(maxcol),b(maxcol)
	logical		bmap
c
c------ set display size
c
	ratio = (24.70/17.45)
	if (orient) then
	  ix_new = iscr_width
	  iy_new = nint(iscr_width/ratio)
	else
	  ix_new = nint(iscr_width/ratio)
	  iy_new = iscr_width
	endif
c
c------ check if be need bitmap colors
c
	bmap = .false.
	bcol = 0
	do i=1,iz-1
	  bmap = bmap .or. (lni(i) .and. (hlineart(i).ne.1))
	enddo
c
	if (bmap) then
	  do i=1,maxcol
	    r(i) = nint(maxcol*col_map(i,1))
	    g(i) = nint(maxcol*col_map(i,2))
	    b(i) = nint(maxcol*col_map(i,3))
	  enddo
	  bcol = col_typ
	endif
c
c------ now init X11 screen
c
	call x11init (ix_new,iy_new,bcol,r,g,b)
c
	if (bmap) col_typ=bcol
c
	end
c****7******************************************************************
	subroutine open_x11 
c+
c	initialisieren des x11-schirms, berechnen der abbildungsfaktoren
c-
	implicit	none
c
	include		'kuplot.inc'
c
	fakx     = (frame(iframe,3)-frame(iframe,1))* 4096./(wxmax-wxmin)
	faky     = (frame(iframe,4)-frame(iframe,2))* 4096./(wymax-wymin)
	shiftx   = frame(iframe,1) * 4096.
	shifty   = frame(iframe,2) * 4096.
	xnull    = wxmin
	ynull    = wymin
c
	end
c*****7*****************************************************************
	subroutine close_x11 
c+
c	alles zu ende
c-
	implicit 	none
c
	call x11close
c
	end
c*****7*****************************************************************
	subroutine colrgb_x11 (r,g,b) 
c+
c	setzen der farbe
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		r,g,b
	integer 	ir,ig,ib
c
	ir = nint(maxcol*r)
	ig = nint(maxcol*g)
	ib = nint(maxcol*b)
c
	call x11colrgb  (ir,ig,ib)
c
	end
c*****7*****************************************************************
	subroutine col_x11 (icol) 
c+
c	setzen der farbe
c-
	implicit	none
c
	integer		icol
c
	call x11col  (icol)
c
	end
c*****7*****************************************************************
	subroutine ltyp_x11 (ityp,lwid) 
c+
c	setzen linienattribut
c-
	implicit	none
c
	real		lwid
	integer		ityp
c
	call x11ltyp (ityp,lwid)
c
	end
c*****7*****************************************************************
	subroutine fsize_x11 (fsize,fid) 
c+
c	setzen fontgroesse
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		fsize,chx,chy
	real		fak_pl,fak_pl_x,fak_pl_y
	integer		fid,isizefont
c
        fak_pl_x  = (frame(iframe,3)-frame(iframe,1))
        fak_pl_y  = (frame(iframe,4)-frame(iframe,2))
        fak_pl    = (fak_pl_x+fak_pl_y)/2.
        isizefont = nint(fsize * fak_pl)
c
	call x11setfont (isizefont,fid)
	call x11getfont (chx,chy)
	charhx   = chx / fakx 
	charhy   = chy / faky
c
	end
c*****7*****************************************************************
	subroutine text_x11 (xp,yp,text,jmode)
c+
c	zeichnen von text
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*(*)	text
	character*80	dummy
	real		xp,yp,xt,yt
	integer		jmode,il,i
	integer		cfeld(132)
c
	integer		len_str
c
	xt = ((xp-xnull)*fakx)+shiftx	
	yt = ((yp-ynull)*faky)+shifty
	dummy=text	
	il=len_str(dummy)
	do i=1,il
	  cfeld(i)=ichar(dummy(i:i))
	enddo
	if (il.gt.0) then
	  call x11text (cfeld,il,xt,yt,jmode)
	  xp = xt/fakx
	  yp = yt/faky
	endif
c
	end
c*****7*****************************************************************
	subroutine pline_x11 (npkt,xa,ya)
c+
c	polyline ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt,i
	real		x1,y1,x2,y2
	real		xa(npkt),ya(npkt)
c
	do i=2,npkt
	  x1 = ((xa(i-1)-xnull)*fakx)+shiftx
	  y1 = ((ya(i-1)-ynull)*faky)+shifty
	  x2 = ((xa(i)-xnull)*fakx)+shiftx
	  y2 = ((ya(i)-ynull)*faky)+shifty
	  call x11line (x1,y1,x2,y2)
	enddo
c
	end
c*****7*****************************************************************
	subroutine rect_x11 (npkt,xpp,ypp,fill)
c+
c       rechteck zeichnen
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt
	real		xpp(npkt),ypp(npkt)
	logical 	fill
c
	real		xp(4),yp(4)
	integer		i
c
	do i=1,npkt
          xp(i) = ((xpp(i)-xnull)*fakx)+shiftx
          yp(i) = ((ypp(i)-ynull)*faky)+shifty
	enddo
c
	if (fill) then
	  call x11fillrect (xp(1),yp(1),xp(2),yp(2),
     &	                    xp(3),yp(3),xp(4),yp(4))
	else
	  call x11rect     (xp(1),yp(1),xp(2),yp(2),
     &	                    xp(3),yp(3),xp(4),yp(4))
	endif
c
	end
c*****7*****************************************************************
        subroutine circ_x11 (xlu,ylu,xro,yro,fill)
c+
c       rechteck zeichnen
c-
	implicit	none
c
        include         'kuplot.inc'
c
	real		xlu,ylu,xro,yro
	real		x1,y1,x2,y2
        logical         fill
c
        x1 = ((xlu-xnull)*fakx)+shiftx
        y1 = ((ylu-ynull)*faky)+shifty
        x2 = (xro*fakx)
        y2 = (yro*faky)
        if (fill) then
          call x11fillcirc (x1-x2,y1+y2,x2*2,y2*2)
        else
          call x11circ (x1-x2,y1+y2,x2*2,y2*2)
        endif
c
        end
c*****7*****************************************************************
	subroutine bitmap_x11 (ik)
c+
c	bitmapdarstellung auf x11-schirmen
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'wink.inc'
c
	character*1	datafeld(maxarray)
	integer		ik,ixx,iyy,jxx,jyy,izw,ix,iy,ii,ikk
	integer		nx_min,nx_max,ny_min,ny_max
	integer		nx_out,ny_out,nx_inc,ny_inc
	integer		maxc,ir,ig,ib
	real		rdx,rdy,zzmin,zzmax,sfak
c
	maxc = maxcol-1
c
	ir = nint(maxcol*frback(iframe,1))
	ig = nint(maxcol*frback(iframe,2))
	ib = nint(maxcol*frback(iframe,3))
c
        ixx = nint((max(ex(iframe,1),xmin(ik))-xnull)*fakx)+shiftx
        iyy = nint((max(ey(iframe,1),ymin(ik))-ynull)*faky)+shifty
        jxx = nint((min(ex(iframe,2),xmax(ik))-xnull)*fakx)+shiftx
        jyy = nint((min(ey(iframe,2),ymax(ik))-ynull)*faky)+shifty
c
        rdx   =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
        rdy   =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
        nx_min=nint(((max(xmin(ik),ex(iframe,1))-xmin(ik))/rdx))+1
        nx_max=nint(((min(xmax(ik),ex(iframe,2))-xmin(ik))/rdx))+1
        ny_min=nint(((max(ymin(ik),ey(iframe,1))-ymin(ik))/rdy))+1
        ny_max=nint(((min(ymax(ik),ey(iframe,2))-ymin(ik))/rdy))+1
        nx_out=nx_max-nx_min+1
        ny_out=ny_max-ny_min+1
	nx_inc=1
	ny_inc=-1
c
	if (x((ik-1)*maxpkt+1).gt.x((ik-1)*maxpkt+2)) then
	  izw=nx_min
	  nx_min=nx_max
	  nx_max=izw
	  nx_inc=-nx_inc
	endif
	if (y((ik-1)*maxpkt+1).gt.y((ik-1)*maxpkt+2)) then
	  izw=ny_min
	  ny_min=ny_max
	  ny_max=izw
	  ny_inc=-ny_inc
	endif
c
        if (nx_out.lt.1 .or. ny_out.lt.1) return
c
        zzmin=z_min(iframe,1)
        zzmax=nz(iframe,1)*z_inc(iframe,1)+z_min(iframe,1)
	ii=1
        do iy=ny_max,ny_min,ny_inc
          do ix=nx_min,nx_max,nx_inc
            ikk=(ik-1)*nx(1)*ny(1)+(ix-1)*ny(ik)+iy
            if(z(ikk).eq.-9999. .or. z(ikk).lt.zzmin) then
              datafeld(ii)=char(maxc)
            elseif(z(ikk).gt.zzmax) then
              datafeld(ii)=char(0)
            else
              datafeld(ii)=char(maxc-nint((z(ikk)-zzmin)*
     &	                       (float(maxc)/(zzmax-zzmin))))
            endif
	    ii=ii+1
          enddo
        enddo
c
	if (shear(iframe).ne.90) then
	  sfak=tan(rad*shear(iframe))
	else
	  sfak=0.0
	endif
c
	call x11bitmap (datafeld,nx_out,ny_out,ixx,iyy,jxx,jyy,
     &	                zzmin,zzmax,sfak,ir,ig,ib)
	end
c*****7*****************************************************************
	subroutine in_x11 (wx,wy,key)
c+
c	eingabe per fadenkreuz 
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*(*)	key
	real		wx,wy
	integer		ix,iy,iret
c
	call x11in (ix,iy,iret)
c
	wx  = (ix-shiftx)/fakx + xnull
	wy  = (iy-shifty)/faky + ynull
	if (iret.eq.1024) then
	  key='a'
	else
	  key='w'
	endif
c
	end
c*****7*****************************************************************
	subroutine set_xscreen (zeile,lp)
c*
c	set the screen width for X11 screens
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=1)
c	
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  iscr_width = 640
	elseif (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  iwidth=nint(werte(1))
	  if (iwidth.ge.10 .and. iwidth.le.2000) then
	    iscr_width=iwidth
	  else
	    ier_num = -16
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
